/*
    contains the following functions:
*/
         void SaganIntitialSettings();
         void PutHoleNamesInList();
         void SetMinMax();
         void SetLogMinMax();
         void SetDisplayDefaults();
         int  GetDisplayValues();
         void AxisDep();
         void AxisVar();
         void AxesCorrelate();
         void AxesAdjustToTiesInfo();
         void MakeTheGCs();
         void MakeClipMask();
         void SetInitialColors();
         void DrawCores();
         void DrawLog();
         void DrawAdjustToTiesInfo();
         void DrawCorrelate();
         void FindNearestSample();
         int  CleanUpCore();
         void ReadColorList();
         int  GetColorPixelValue();
         void CustomColorBackgroundChange();
         void CustomColorLabelChange();
         void SetCustomeColorButtonColors();
         void SetColorSetBGandFG();
         int  MapEqLogDepthToData();
         void GetColor();
         void DrawAutoCorrelate();
         int  AutoCoreAdjAxesAndGrid();
         void AutoCoreAdjustDrawBox();
         int  GetColorSet();
         void SetColorSet();

#include <Xm/Xm.h>
#include <Xm/Text.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "sagan-creation-c.h"
#include "sagan_vars.h"

char    buffer[MAXBUF];

void SaganInitialSettings(dpy)
Display *dpy;
{
  char   *string;
  time_t tp;
  int    i;
  XmString xmstring;
  XmTextPosition  pos;

/*
  if((string=(char*)calloc(1000, CHAR_SIZE))==NULL)
                 SaBadMemAlloc("");
  (void)strcpy(string,(char*)getenv("WHERE_AM_I"));
  for(i=0; i<strlen(string); ++i) {
    string[i] = toupper(string[i]);
  }
  if(strcmp(string, "SHIP") == 0) {
    whereami = SHIP;
  }
  else if(strcmp(string, "SHORE") == 0) {
    whereami = SHORE;
  }
  else {
    whereami = SHORE;
  }
  free(string);
*/

  dataset_cnt = 0;
  dset = 0;
  splice_cnt = 0;
  sset = 0;
  logset_cnt = 0;
  lset = 0;
  total_num_ties = 0;
  max_num_cores = 0;
  XtUnmanageChild(optionMenuDataSet);
  XtUnmanageChild(pushButtonDataSet1);
  XtUnmanageChild(pushButtonDataSet2);
  XtUnmanageChild(pushButtonDataSet3);
  XtUnmanageChild(pushButtonDataSet4);
  XtUnmanageChild(pushButtonDataSet5);
  XtUnmanageChild(pushButtonDataSet6);
  XtUnmanageChild(pushButtonDataSet7);
  XtUnmanageChild(pushButtonDataSet8);
  XtUnmanageChild(pushButtonDataSet9);
  XtUnmanageChild(optionMenuLogSet);
  XtUnmanageChild(pushButtonLogSet1);
  XtUnmanageChild(pushButtonLogSet2);
  XtUnmanageChild(pushButtonLogSet3);
  XtUnmanageChild(pushButtonLogSet4);
  XtUnmanageChild(pushButtonLogSet5);
  XtUnmanageChild(pushButtonLogSet6);
  XtUnmanageChild(pushButtonLogSet7);
  XtUnmanageChild(pushButtonLogSet8);
  XtUnmanageChild(pushButtonLogSet9);
  have_cores = DONT;
  have_splice = DONT;
  have_splice_table = DONT;
  splice_did_warn = NO;
  have_log = have_anc1=have_anc2=have_anc3=DONT;
  have_affine = DONT;
  have_autocorr = DONT;
  have_strat = DONT;
  core_clip_what = NONE;
  log_clip_what = NONE;
  are_reading_dataset = NO;
  are_reading_log = NO;
  autocoreadj.is_allocated = NO;
  autocoreadj.override_aff = NO;
  autocoreadj.draw_results = NO;
  corr_rank.n = 0;
  ancill.axislen = VAR_AXIS_LEN;
  eld.nholes = 0;
  eld.hole_eqt = NULL;
  autopair = NO;
  xmstring = XmStringCreateSimple("Auto Pair Off");
  XtVaSetValues(labelAutoPair, XmNlabelString, xmstring, NULL);
  XtVaSetValues(pushButtonPairCoreLog, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);
  XtSetSensitive(pushButtonPairCoreLog, False);
  XtSetSensitive(labelAutoPair, False);

  if((loginfo.id=(char**)calloc(1,sizeof(char*)))==NULL)
                SaBadMemAlloc("Sa");
  if((loginfo.id[0]=(char*)calloc(25,CHAR_SIZE))==NULL)
                SaBadMemAlloc("Sa");     

  XmToggleButtonSetState(toggleButtonODPOtherFormat1,True,True);
  XtVaSetValues(scaleLog, XmNmaximum, 1, NULL);
  XmToggleButtonSetState(toggleButtonAddTieToCore, False, False);
  XmToggleButtonSetState(toggleButtonAddTieToAll, True, False);

  XmToggleButtonSetState(toggleButtonHeaderNo, True, NULL);
  XmToggleButtonSetState(toggleButtonHeaderYes, False, NULL);

  MakeTheGCs(dpy);
  SetInitialColors(dpy);
  SetDisplayDefaults();
  ReadColorList(dpy);

  /* write to report
  */
  XtManageChild(formReport);
  if((string=(char*)calloc(1000, CHAR_SIZE))==NULL)
                 SaBadMemAlloc("");
  if(time(&tp)) {
    (void)sprintf(string,"Start of Session.  %s",ctime(&tp));
  }
  else {
    (void)sprintf(string, "Start of Session. No date available.\n");
  }
  SaUpdateReport(string);
  free(string);
  XtPopdown(XtParent(formReport));

  XtSetSensitive(optionMenuLogFormat, False);
  XtSetSensitive(pushButtonEvalCoreLogData, False);
  XtSetSensitive(optionMenuLogCoreType, True);
  XtSetSensitive(pushButtonOpenSpliceTable, False);
  XtSetSensitive(pushButtonOpenSplicer, False);
  XtSetSensitive(pushButtonClearSplice, False);
  XtVaSetValues(formEquivLogDepthTool, XmNmappedWhenManaged, True, NULL);
  XtSetSensitive(formEquivLogDepthTool, False);
  XtVaSetValues(formLogAdjustmentTool, XmNmappedWhenManaged, False, NULL);
  XtVaSetValues(textFieldSelectHole, XmNvalue, "", NULL);
  XtVaSetValues(textFieldSelectCore, XmNvalue, "", NULL);

  have_coretotie = DONT;
  have_tie1 = DONT;
  have_tie2 = DONT;
  have_ties = DONT;
  last_tie = NONE;
  have_correlate = DONT;
  eqlogdepth.autocorr_status = NO;
  eqlogdepth.did_log_mudline_adj = NO;

  /* alloc the tie list that will hold all the tie info
     for core being worked on
     will alloc its pt members in callbacks as needed
  */
  if((ties=(Ties*)calloc(1,sizeof(Ties)))==NULL)
                                SaBadMemAlloc("Sa");

  ties->nties = 0;
  ties->alloc_cnt = 0;
  ties->winlen = WINLEN;
  ties->leadlag = LEADLAG;
 
  /* set the window length, lead,lag and depth step to the defaults
  */
  if((string=(char*)calloc(100, CHAR_SIZE))==NULL)
                 SaBadMemAlloc("");
  (void)sprintf(string, "%.2f", ties->winlen);
  XtVaSetValues(textFieldWindowLength, XmNvalue, string, NULL);
  (void)sprintf(string, "%.2f", ties->leadlag);
  XtVaSetValues(textFieldLeadLag, XmNvalue, string, NULL);
  (void)sprintf(string, "%.2f", DEPSTEP);
  XtVaSetValues(textFieldDepthStep, XmNvalue, string, NULL);
  free(string);

  /* set the auto corr offset and squish params to defualts
  */
  if((string=(char*)calloc(50,CHAR_SIZE))==NULL)
                                SaBadMemAlloc("Sa");
  (void)sprintf(string, "%.2f", STRETCH);
  XtVaSetValues(textFieldAutoCorrSquish1, XmNvalue, string, NULL);
  (void)sprintf(string, "%.2f", SQUISH);
  XtVaSetValues(textFieldAutoCorrSquish2, XmNvalue, string, NULL);
  (void)sprintf(string, "%.2f", INC_SQUISH);
  XtVaSetValues(textFieldAutoCorrSquishInterval, XmNvalue, string, NULL);
  (void)sprintf(string, "%.2f", NEG_OFFSET);
  XtVaSetValues(textFieldAutoCorrOffset1, XmNvalue, string, NULL);
  (void)sprintf(string, "%.2f", POS_OFFSET);
  XtVaSetValues(textFieldAutoCorrOffset2, XmNvalue, string, NULL);
  (void)sprintf(string, "%.2f", INC_OFFSET * LOGDEPSTEP);
  XtVaSetValues(textFieldAutoCorrOffsetInterval, XmNvalue, string, NULL);
  free(string);

  if(eqlogdepth.read_equil_log == YES) {
    XmToggleButtonSetState(toggleButtonUseEqLogDepth, True, False);
    XmToggleButtonSetState(toggleButtonDontUseEqLogDepth, False, False);
  }
  else {
    XmToggleButtonSetState(toggleButtonUseEqLogDepth, False, False);
    XmToggleButtonSetState(toggleButtonDontUseEqLogDepth, True, False);
  }

  if(smooth.method == NONE) {
    smooth.plot = UNSMOOTH;
    XmToggleButtonSetState(toggleButtonSmoothNone, True, False);
    XmToggleButtonSetState(toggleButtonSmoothGaussian, False, False);
    XmToggleButtonSetState(toggleButtonSmoothLowPass, False, False);
    XmToggleButtonSetState(toggleButtonDisplayCoreUnsmoothed, True, False);
    XmToggleButtonSetState(toggleButtonDisplayCoreSmooth, False, False);
    XmToggleButtonSetState(toggleButtonDisplayCoreBoth, False, False);
    XtSetSensitive(formSmoothOptions,False);
  }
  else if(smooth.method == GAUSSIAN || smooth.method == LOWPASS) {
    XmToggleButtonSetState(toggleButtonSmoothNone, False, False);
    XmToggleButtonSetState(toggleButtonSmoothGaussian, True, False);
    XmToggleButtonSetState(toggleButtonSmoothLowPass, False, False);
    if(smooth.width_units == POINTS) {
     XtVaSetValues(optionMenuWidthUnits,XmNmenuHistory, pushButtonUnitsPoints, NULL);
    }
    else if(smooth.width_units == DEPTH) {
      XtVaSetValues(optionMenuWidthUnits,XmNmenuHistory, pushButtonUnitsDepth, NULL);
    }
    else {
      smooth.width_units = DEPTH;
      XtVaSetValues(optionMenuWidthUnits,XmNmenuHistory, pushButtonUnitsDepth, NULL);
    }
    if((charptr=(char*)calloc(50,CHAR_SIZE))==NULL)
         SaBadMemAlloc("SaInitialize");
    (void)sprintf(charptr, "%d", smooth.width);
    XtVaSetValues(textFieldSmoothWidth, XmNvalue, charptr, NULL);
    free(charptr);
    if(smooth.plot == UNSMOOTH) {
      XmToggleButtonSetState(toggleButtonDisplayCoreUnsmoothed, True, False);
      XmToggleButtonSetState(toggleButtonDisplayCoreSmooth, False, False);
      XmToggleButtonSetState(toggleButtonDisplayCoreBoth, False, False); 
    }
    else if(smooth.plot == SMOOTH) {
      XmToggleButtonSetState(toggleButtonDisplayCoreUnsmoothed, False, False); 
      XmToggleButtonSetState(toggleButtonDisplayCoreSmooth, True, False);
      XmToggleButtonSetState(toggleButtonDisplayCoreBoth, False, False);
    }
    else if(smooth.plot == SMOOTHBOTH) {
      XmToggleButtonSetState(toggleButtonDisplayCoreUnsmoothed, False, False); 
      XmToggleButtonSetState(toggleButtonDisplayCoreSmooth, False, False);
      XmToggleButtonSetState(toggleButtonDisplayCoreBoth, True, False);
    }
    else {
      smooth.plot = SMOOTHBOTH;
      XmToggleButtonSetState(toggleButtonDisplayCoreUnsmoothed, False, False); 
      XmToggleButtonSetState(toggleButtonDisplayCoreSmooth, False, False);
      XmToggleButtonSetState(toggleButtonDisplayCoreBoth, True, False);
    }
    XtSetSensitive(formSmoothOptions,True);
  }
  else {
    smooth.method = NONE;
    smooth.plot = UNSMOOTH;
    XmToggleButtonSetState(toggleButtonSmoothNone, True, False);
    XmToggleButtonSetState(toggleButtonSmoothGaussian, False, False);
    XmToggleButtonSetState(toggleButtonSmoothLowPass, False, False);
    XmToggleButtonSetState(toggleButtonDisplayCoreUnsmoothed, True, False);
    XmToggleButtonSetState(toggleButtonDisplayCoreSmooth, False, False);
    XmToggleButtonSetState(toggleButtonDisplayCoreBoth, False, False);
    XtSetSensitive(formSmoothOptions,False);
  }

  if(loginfo.smooth.method == NONE) {
    loginfo.smooth.plot = UNSMOOTH;
    XmToggleButtonSetState(toggleButtonDisplayLogUnsmoothed, True, False);
    XmToggleButtonSetState(toggleButtonDisplayLogSmooth, False, False);
    XmToggleButtonSetState(toggleButtonDisplayLogBoth, False, False);
  }
  else if(loginfo.smooth.method == GAUSSIAN || loginfo.smooth.method == LOWPASS) {
    if(loginfo.smooth.plot == UNSMOOTH) {
      XmToggleButtonSetState(toggleButtonDisplayLogUnsmoothed, True, False);
      XmToggleButtonSetState(toggleButtonDisplayLogSmooth, False, False);
      XmToggleButtonSetState(toggleButtonDisplayLogBoth, False, False);
    }
    else if(loginfo.smooth.plot == SMOOTH) {
      XmToggleButtonSetState(toggleButtonDisplayLogUnsmoothed, False, False);
      XmToggleButtonSetState(toggleButtonDisplayLogSmooth, True, False);
      XmToggleButtonSetState(toggleButtonDisplayLogBoth, False, False);
    }
    else if(loginfo.smooth.plot == SMOOTHBOTH) {
      XmToggleButtonSetState(toggleButtonDisplayLogUnsmoothed, False, False);
      XmToggleButtonSetState(toggleButtonDisplayLogSmooth, False, False);
      XmToggleButtonSetState(toggleButtonDisplayLogBoth, True, False);
    }
    else {
      loginfo.smooth.plot = SMOOTHBOTH;
      XmToggleButtonSetState(toggleButtonDisplayLogUnsmoothed, False, False);
      XmToggleButtonSetState(toggleButtonDisplayLogSmooth, False, False);
      XmToggleButtonSetState(toggleButtonDisplayLogBoth, True, False);
    }
  }
  else {
    loginfo.smooth.method = NONE;
    loginfo.smooth.plot = UNSMOOTH;
    XmToggleButtonSetState(toggleButtonDisplayLogUnsmoothed, True, False);
    XmToggleButtonSetState(toggleButtonDisplayLogSmooth, False, False);
    XmToggleButtonSetState(toggleButtonDisplayLogBoth, False, False);
  }

   /* pop up the job select dialog 
   
   XtManageChild(formSelectJob);
   XtPopup(XtParent(formSelectJob),XtGrabNone);
   XtVaSetValues(formSelectJob, XmNx, 300, XmNy, 200, NULL);
*/
                
   /* and set the default toggle
   */
   if(job == MCD_VS_LOG) {
     XmToggleButtonSetState(toggleButtonSelectJob1, True, False);
     XmToggleButtonSetState(toggleButtonSelectJob2, False, False);
     XmToggleButtonSetState(toggleButtonSelectJob3, False, False);
   }
   else if(job == SPLICE_VS_LOG) {
     XmToggleButtonSetState(toggleButtonSelectJob1, False, False);
     XmToggleButtonSetState(toggleButtonSelectJob2, True, False);
     XmToggleButtonSetState(toggleButtonSelectJob3, False, False);
   }
   else if(job == MBSF_VS_LOG) {
     XmToggleButtonSetState(toggleButtonSelectJob1, False, False);
     XmToggleButtonSetState(toggleButtonSelectJob2, False, False);
     XmToggleButtonSetState(toggleButtonSelectJob3, True, False);
   }
   else {
     job = MCD_VS_LOG;
     XmToggleButtonSetState(toggleButtonSelectJob1, True, False);
     XmToggleButtonSetState(toggleButtonSelectJob2, False, False);
     XmToggleButtonSetState(toggleButtonSelectJob3, False, False);
   }

   /* make only approprate menu buttons sensitive
   */
   XtSetSensitive(pushButtonAccessDatabase, False);
   XtSetSensitive(pushButtonOpenStrat, False);
   XtSetSensitive(pushButtonOpenSpliceTable, False);
   XtSetSensitive(pushButtonSaveEquvilentLogDepthTable, False);
   XtSetSensitive(pushButtonSaveCoreData, False);
   XtSetSensitive(pushButtonSaveSplice, False);
   XtSetSensitive(pushButtonSaveStrat, False);
   XtSetSensitive(pushButtonClearAll, False);
   XtSetSensitive(pushButtonClearCores, False);
   XtSetSensitive(pushButtonClearLog, False);
   XtSetSensitive(pushButtonClearAncillary, False);
   XtSetSensitive(pushButtonClearSplice, False);
   XtSetSensitive(pushButtonClearStrat, False);
   XtSetSensitive(cascadeButtonProcessData, False);
   XtSetSensitive(cascadeButtonProcessLog, False);
   XtSetSensitive(pushButtonAutoCorrelate, False);

  /* set the core depth type buttons to their colors
  */
  XtVaSetValues(pushButtonmbsfColor, XmNbackground, fgPixel[CLINE_COREODPSBD], NULL);
  XtVaSetValues(pushButtonmcdColor, XmNbackground, fgPixel[CLINE_COREMCD], NULL);
  XtVaSetValues(pushButtoneldColor, XmNbackground, fgPixel[CLINE_COREEQUIVLOGDEPTH], NULL);
  XtVaSetValues(pushButtonlogColor, XmNbackground, fgPixel[CLINE_LOG], NULL);
  XtVaSetValues(pushButtonlogMLadjColor, XmNbackground, fgPixel[CLINE_LOGADJDEPTH], NULL);
  XtVaSetValues(pushButtonmbsfColor, XmNforeground, bgPixel, NULL);
  XtVaSetValues(pushButtonmcdColor, XmNforeground, bgPixel, NULL);
  XtVaSetValues(pushButtoneldColor, XmNforeground, bgPixel, NULL);
  XtVaSetValues(pushButtonlogColor, XmNforeground, bgPixel, NULL);
  XtVaSetValues(pushButtonlogMLadjColor, XmNforeground, bgPixel, NULL);
}

void PutHoleNamesInList(ds)
int ds;
{
  int i;
  char string[50];
  XmString xmstring;

  for(i=0; i<data[ds]->numholes; ++i) {
    (void)sprintf(string, "leg %d  site %d  hole %c", data[ds]->leg, data[ds]->site, data[ds]->holes[i]->name);
    xmstring = XmStringCreateSimple(string);
    XmListAddItem(listSuggestLogDepthAdjustHolePick, xmstring, i+1);
    XmStringFree(xmstring);
  }
  for(i=0; i<data[ds]->numholes; ++i) {
    (void)sprintf(string, "leg %d  site %d  hole %c", data[ds]->leg, data[ds]->site, data[ds]->holes[i]->name);
    xmstring = XmStringCreateSimple(string);
    XmListAddItem(listSuggestLogDepthAdjustHolePick, xmstring, i+1+data[ds]->numholes);
    XmStringFree(xmstring);
  }

  XmListSetPos(listSuggestLogDepthAdjustHolePick,1);
/*
  XmListDeselectAllItems(listSuggestLogDepthAdjustHolePick);
*/
  XmListSetBottomPos(listSuggestLogDepthAdjustHolePick, 2 * data[ds]->numholes);
}

void SetMinMax(ds)
int ds;
{
  int scalemax;
  char string[50];

  if(data[ds]->max > data[ds]->min) {
    (void)sprintf(string, "%.2f", data[ds]->min); 
    XtVaSetValues(textFieldVarMin, XmNvalue, string, NULL); 
    (void)sprintf(string, "%.2f", data[ds]->max); 
    XtVaSetValues(textFieldVarMax, XmNvalue, string, NULL); 

    scalemax = maxdep + (0.2 * maxdep);
    if(scalemax < 1) {
      scalemax = maxdep + 1;
    }
    XtVaSetValues(scaleDrawingAreas, XmNmaximum, scalemax, NULL);
  }
  else {
    
  }
}

void SetLogMinMax(log)
LogData log;
{
  int scaleval;
  char string[50];

  (void)sprintf(string, "%.2f", log.axis_min);
  XtVaSetValues(textFieldLogMinimum, XmNvalue, string, NULL);
  (void)sprintf(string, "%.2f", log.axis_max);
  XtVaSetValues(textFieldLogMaximum, XmNvalue, string, NULL);
 
  scaleval = maxdep;
  XtVaSetValues(scaleDrawingAreas, XmNmaximum, scaleval, NULL);
}

void SetDisplayDefaults()
{
  int scalemax;
  char string[50];

  depmeterdisplayed = DEPMETERDISPLAYED;
  (void)sprintf(string, "%.3f", depmeterdisplayed);
  XtVaSetValues(textFieldMetersDisplayed, XmNvalue, string, NULL);

  deptic = DEPTIC;
  (void)sprintf(string, "%.1f", deptic); 
  XtVaSetValues(textFieldMeterTick, XmNvalue, string, NULL); 

  XtSetSensitive(formSmoothOptions,False);
  XtVaSetValues(optionMenuWidthUnits,XmNmenuHistory,pushButtonUnitsPoints,NULL);

  varaxislen = VAR_AXIS_LEN;
  (void)sprintf(string, "%d", varaxislen); 
  XtVaSetValues(textFieldVarAxisLen, XmNvalue, string, NULL); 

  minvar = 0.0;
  (void)sprintf(string, "%.2f", minvar); 
  XtVaSetValues(textFieldVarMin, XmNvalue, string, NULL); 

  maxvar = 0.0;
  (void)sprintf(string, "%.2f", maxvar);
  XtVaSetValues(textFieldVarMax, XmNvalue, string, NULL); 


  XtVaSetValues(optionMenuDisplayLogType,XmNmenuHistory,pushButtonDisplayLog,NULL); 
  logaxislen = LOG_AXIS_LEN;
  (void)sprintf(string, "%d", logaxislen);
  XtVaSetValues(textFieldLogAxisLen, XmNvalue, string, NULL);
     
  minlog = 0.0;
  (void)sprintf(string, "%.2f", minlog);
  XtVaSetValues(textFieldLogMinimum, XmNvalue, string, NULL);
     
  maxlog = 0.0;
  (void)sprintf(string, "%.2f", maxlog);
  XtVaSetValues(textFieldLogMaximum, XmNvalue, string, NULL);

  scale_mult = SCALE_MULT;
  (void)sprintf(string, "%d", scale_mult); 
  XtVaSetValues(textFieldScrollStep, XmNvalue, string, NULL); 

  XtVaSetValues(scaleDrawingAreas, XmNscaleMultiple, scale_mult, NULL);

  maxdep = MAXDEP;
  scalemax = maxdep;
  XtVaSetValues(scaleDrawingAreas, XmNmaximum, scalemax, NULL);

  XmToggleButtonSetState(toggleButtonScaleDragYes, True, NULL);
  XmToggleButtonSetState(toggleButtonScaleDragNo, False, NULL);
}


int GetDisplayValues(ds, ls)
int ds;
{
  double check, fract, ip;
  char string[20];
  String  str;
  Widget tmp_widget;
  int which_axis, who;

  str = XmTextGetString(textFieldMetersDisplayed);
  depmeterdisplayed = atof(str);
  XtFree(str);

  /* check that meters display is a whole number >= 1
  */
  
  check = depmeterdisplayed;
  fract = modf(check, &ip);
  if(fract != 0.0){
    depmeterdisplayed = DEPMETERDISPLAYED;
    (void)sprintf(buffer,"meters displayed must be a whole number.");
    SaManageWarningBox(buffer); 
    return 1;
  }
  if(depmeterdisplayed < 1.0){
    depmeterdisplayed = DEPMETERDISPLAYED;
    (void)sprintf(buffer,"meters displayed must be greater than or equal to 1.0."); 
    SaManageWarningBox(buffer); 
    return 1;
  }

  str = XmTextGetString(textFieldMeterTick); 
  deptic = atof(str);
  XtFree(str);


  /* check that the depth tic is a whole number and divides evenly into number
     of meters displayed
  */
  check = deptic;
  fract = modf(check, &ip);
  if(fract != 0.0){
    deptic = DEPTIC;
    (void)sprintf(buffer,"the depth tic must be a whole number.");
    SaManageWarningBox(buffer); 
    return 1;
  }
  check = depmeterdisplayed/deptic;
  fract = modf(check, &ip);
  if(fract != 0.0){
    deptic = DEPTIC;
    (void)sprintf(buffer,"the depth tic interval must divide evenly into number of meters displyed");
    SaManageWarningBox(buffer); 
    return 1;
  }

  str = XmTextGetString(textFieldVarAxisLen); 
  varaxislen = atoi(str);
  XtFree(str);


  /* check that the var axis length has some length
  */
  if(varaxislen < 10){
    varaxislen = VAR_AXIS_LEN;
    (void)sprintf(buffer,"the variable axis pixel length is unreasonably small.");
    SaManageWarningBox(buffer); 
    return 1;
  }

  str = XmTextGetString(textFieldVarMin); 
  minvar = atof(str);
  XtFree(str);

  str = XmTextGetString(textFieldVarMax); 
  maxvar = atof(str);
  XtFree(str);


  /* check that the max is greater than the min and the range is not 
     approaching zero
  */
  if(maxvar < minvar){
    (void)sprintf(buffer,"the variable axis maximum is less than its minimum."); 
    SaManageWarningBox(buffer); 
    return 1; 
  }
  if(have_cores == DO){
    if(maxvar == minvar){
      (void)sprintf(buffer,"the variable axis minimum equals its maximum."); 
      SaManageWarningBox(buffer); 
      return 1;  
    }
    if(fabs(maxvar - minvar) < 0.1){
      (void)sprintf(buffer,"the variable axis range is unreasonably small."); 
      SaManageWarningBox(buffer); 
      return 1; 
    }
  }

  if(have_cores == DO) {
    data[ds]->min = minvar;
    data[ds]->max = maxvar;
  }


/* find which log axis is being altered */
        XtVaGetValues(optionMenuDisplayLogType,XmNmenuHistory,&tmp_widget,NULL); 
        XtVaGetValues(tmp_widget,XmNuserData,&which_axis,NULL);

	if(which_axis == LOG)
	{
  		str = XmTextGetString(textFieldLogAxisLen);
  		logaxislen = atoi(str);
  		XtFree(str);
	

  		/* check that the log axis length has some length
  		*/
  		if(logaxislen < 10){
    		  logaxislen = LOG_AXIS_LEN;
    		  (void)sprintf(buffer,"the log axis pixel length is unreasonably small.");
    		  SaManageWarningBox(buffer); 
    		  return 1;
  		}    
		 
  		str = XmTextGetString(textFieldLogMinimum);
  		minlog = atof(str);
  		XtFree(str);

		str = XmTextGetString(textFieldLogMaximum);
  		maxlog = atof(str);
  		XtFree(str);
			 
			 
  		/* check that the max is greater than the min and the range is not
     		approaching zero
  		*/   
  		if(maxlog < minlog){
    		   (void)sprintf(buffer,"the log axis maximum is less than its minimum.");
    		   SaManageWarningBox(buffer); 
    		   return 1;
  		}    
  		if(have_log == DO){
    		   if(maxlog == minlog){
      		      (void)sprintf(buffer,"the log axis minimum equals its maximum.");
      		      SaManageWarningBox(buffer); 
      		      return 1;
    		   }  
    		   if(fabs(maxlog - minlog) < 0.1){
      		      (void)sprintf(buffer,"the log axis range is unreasonably small.");
      		      SaManageWarningBox(buffer); 
      		      return 1;
    		   }  
                   logdata[ls]->axis_min = minlog;
                   logdata[ls]->axis_max = maxlog;
                }
        }
	else
        { 
                who = -1;
        	if(which_axis == ANC1)
                {
                  who = 0;
                }
                else if(which_axis == ANC2)
                {
                  who = 1;
                }
                else if(which_axis == ANC3)
                {
                  who = 2;
                }
                if(who != -1) 
                {
  			str = XmTextGetString(textFieldLogAxisLen);
  			ancill.axislen = atoi(str);
  			XtFree(str);


  			if(ancill.axislen < 10){
    			   ancill.axislen = LOG_AXIS_LEN;
    			   (void)sprintf(buffer,"the ancillary  axis pixel length is unreasonably small.");
    			   SaManageWarningBox(buffer); 
    			   return 1;
  			}    
  			str = XmTextGetString(textFieldLogMinimum);
  			ancill.axis_min[who]= atof(str);
  			XtFree(str);
			 
  			str = XmTextGetString(textFieldLogMaximum);
  			ancill.axis_max[who]= atof(str);
  			XtFree(str);
			 
  			if(ancill.axis_max< ancill.axis_min){
    				(void)sprintf(buffer,"the ancillary axis maximum is less than its minimum.");
    				SaManageWarningBox(buffer); 
    				return 1;
  			}    
    			if(ancill.axis_max == ancill.axis_min){
      				(void)sprintf(buffer,"the ancillary axis minimum equals its maximum.");
      				SaManageWarningBox(buffer); 
      				return 1;
    			}  
    			if(fabs(ancill.axis_max- ancill.axis_min) < 0.1){
      				(void)sprintf(buffer,"the ancillary axis range is unreasonably small.");
      				SaManageWarningBox(buffer); 
      				return 1;
    			}  
		}
		else
                {
                }
	}	

  /* check that slider scale is a whole number greater than or equal to one
  */
  str = XmTextGetString(textFieldScrollStep);
  check = atof(str);
  XtFree(str);
	
  fract = modf(check, &ip);
  if(fract != 0.0){
    (void)sprintf(buffer,"the scroll increment must be a whole number.");
    SaManageWarningBox(buffer); 
    scale_mult = SCALE_MULT;
    (void)sprintf(string, "%d", scale_mult);
    XtVaSetValues(textFieldScrollStep, XmNvalue, string, NULL);
  }
  else {
    scale_mult = check;
  }
  if(scale_mult < 1){
    (void)sprintf(buffer,"the scroll increment must be greater than or equal to 1.0."); 
    SaManageWarningBox(buffer); 
    scale_mult = SCALE_MULT; 
    (void)sprintf(string, "%d", scale_mult);
    XtVaSetValues(textFieldScrollStep, XmNvalue, string, NULL);
  }

  XtVaSetValues(scaleDrawingAreas, XmNscaleMultiple, scale_mult, NULL);

  return 0;
}


void AxisDep(w, dpy, wid, gc, maxmeter, topoff, left, ticpixlen, depinc, unitinc, depscalepix, annot, label)
Widget w;
Display *dpy;
Window wid;
GC gc;
int topoff, left, ticpixlen, annot, label;
float unitinc, depscalepix, depinc, maxmeter;
{
  int yoff, laboff, chk;
  char s[50];
  Dimension win_height;

  /* get the height and width of the drawing area
  */
  XtVaGetValues(w, XmNheight, &win_height, NULL);

  /* label the axis
  */
  if(label == YES){
    if(have_affine == DO) {
      (void)sprintf(s,"mcd");
    }
    else {
      (void)sprintf(s,"mbsf");
    }
    XDrawString(dpy, wid, gc, 8, OFF + 30, s, (int)strlen(s));
  }

  yoff = topoff;
  /* draw the depth axis and tic it
  */
  if(left > 0) {
    XDrawLine(dpy, wid, gc, OFF, yoff, OFF, yoff + left);
    yoff = yoff + left;
  }
  laboff=YAXIS_ANNOT_OFF;
  if(unitinc >= 10.0 && unitinc < 100.0) {
    laboff = YAXIS_ANNOT_OFF + 5;
  }
  else if(unitinc >= 100.0) {
    laboff=YAXIS_ANNOT_OFF + 9;
  }
  XDrawLine(dpy, wid, gc, OFF, yoff, OFF-4, yoff);
  (void)sprintf(s,"%.1f",unitinc);
  XDrawString(dpy, wid, gc, OFF-laboff, yoff+2, s, (int)strlen(s));
  chk = 1;
  
  while(yoff+ticpixlen <= (int)win_height && unitinc < maxmeter){
    XDrawLine(dpy, wid, gc, OFF, yoff, OFF, yoff+ticpixlen);
    yoff = yoff + ticpixlen;
    XDrawLine(dpy, wid, gc, OFF, yoff, OFF-4, yoff);
    unitinc = unitinc + depinc;
    if(unitinc >= 10.0 && unitinc < 100.0) {
      laboff = YAXIS_ANNOT_OFF + 5;
    }
    else if(unitinc >= 100.0) {
      laboff=YAXIS_ANNOT_OFF + 9;
    }
    if(chk == annot){
      (void)sprintf(s,"%.1f",unitinc);
      XDrawString(dpy, wid, gc, OFF-laboff, yoff, s, (int)strlen(s));
      chk = 1;
    }
    else {
      ++chk;
    }
  }
  if(yoff < (int)win_height && unitinc < maxmeter) {
    XDrawLine(dpy, wid, gc, OFF, yoff, OFF, (int)win_height);
  }
} 
 
void AxisVar()
{
}

void AxesCorrelate(w, dpy, xid, gc, lagtic, nlagtic, maxlag, ylen, xlen)
Widget w;
Display *dpy;
Window xid;
GC gc;
int lagtic, nlagtic, ylen, xlen;
float maxlag;
{
  int i, m, xoff, yoff, inc;
  char s[50];
  float corr;

  /* draw and label the lead,lag axis and tic it
  */ 
  XDrawString(dpy, xid, gc, SPACE/2, SPACE/2, "lag", 3);
  XDrawString(dpy, xid, gc, xlen + SPACE - 5, SPACE/2, "tie", 3);
  XDrawString(dpy, xid, gc, (xlen * 2) - 2, SPACE/2, "lead", 4);

  m = SPACE;
  yoff = (ylen/2) + SPACE;
  XDrawLine(dpy, xid, gc, m, yoff, m + (xlen * 2), yoff);
  (void)sprintf(s,"%.2f",-1*maxlag);
  XDrawString(dpy, xid, gc, m-5, yoff+15, s, (int)strlen(s));
  (void)sprintf(s,"%.2f", maxlag);
  XDrawString(dpy, xid, gc, m + (xlen * 2) - 5, yoff+15, s, (int)strlen(s));
  inc = (xlen * 2)/nlagtic;
/*
  for(i=0; i <= nlagtic; ++i){
    XDrawLine(dpy, xid, gc, m, yoff-3, m, yoff+3);
    m = m + inc;
  }  
  (void)sprintf(s,"%d", maxlag);
  XDrawString(dpy, xid, gc, m-5-inc, yoff+15, s, (int)strlen(s));
*/
     
  /* draw and label the corr coef axis
  */
  m = SPACE;
  corr = 1.0;
  xoff = SPACE + xlen;
  XDrawLine(dpy, xid, gc, xoff, m, xoff, ylen + SPACE);
  (void)sprintf(s,"%.1f",corr);
  XDrawString(dpy, xid, gc, xoff+10, m+3, s, (int)strlen(s));
  inc = ylen/10;
  for(i=0; i <= 10; ++i){
    XDrawLine(dpy, xid, gc, xoff-3, m, xoff+3, m);
    m = m + inc;
  }  
  (void)sprintf(s,"%.1f",-1*corr);
  XDrawString(dpy, xid, gc, xoff+10, m+3-inc, s, (int)strlen(s));
}

void AxesAdjustToTiesInfo(w, dpy, wid, gc, naxes, width, height)
Widget w;
Display *dpy;
Window wid;
GC gc;
int naxes, width, height;
{
  int i, axiswidth;

  axiswidth = (width - height - 2 * SPACE)/2.0;
  if(axiswidth < 5) {
    return;
  }

  XDrawLine(dpy, wid, gc, OFF+SPACE, OFF,
                            OFF+SPACE+height, OFF);
  XDrawLine(dpy, wid, gc, OFF+SPACE + height + SPACE, OFF, 
                            OFF+SPACE + height + SPACE + axiswidth, OFF);
  XDrawLine(dpy, wid, gc, OFF+SPACE + height + 2 * SPACE + axiswidth, OFF,
                            OFF+SPACE + height + 2 * SPACE + 2 * axiswidth, OFF);
}

void MakeTheGCs(display)
Display *display;
{
  int screen_num;
  XFontStruct *font;

  /* create the GC's for the drawing windows 
  */
  screen_num = DefaultScreen(display);
  gc_drawingAreaCores = XCreateGC(display,
                        RootWindow(display, screen_num),
                        NULL, NULL);
  gc_drawingAreaLog = XCreateGC(display, 
                      RootWindow(display, screen_num), 
                      NULL, NULL);
  gc_drawingAreaAdjustToTiesInfo = XCreateGC(display, 
                                   RootWindow(display, screen_num), 
                                   NULL, NULL);
  gc_drawingAreaCorrelate = XCreateGC(display,
                                   RootWindow(display, screen_num),
                                   NULL, NULL);
  gc_drawingAreaOptimizeTieCorrelate = XCreateGC(display,
                                   RootWindow(display, screen_num),
                                   NULL, NULL);
  gc_drawingAreaSuggestLogDepthAdjustStats = XCreateGC(display,
                                   RootWindow(display, screen_num),
                                   NULL, NULL);
  gc_colorListSelect = XCreateGC(display,
                                   RootWindow(display, screen_num),
                                   NULL, NULL);
  gc_drawingAreaAutoCorrelate = XCreateGC(display,
                                   RootWindow(display, screen_num),
                                   NULL, NULL);
  gc_drawingAreaEvalCoreLogData = XCreateGC(display,
                                   RootWindow(display, screen_num),
                                   NULL, NULL);
  /* and set their fonts
  */
  if(!(font = XLoadQueryFont(display, "-*-helvetica-*-r-*--12-*"))) {
    (void)printf("MakeTheGCs; drawing area font query failed\n");
  }
  else {
    XSetFont(display, gc_drawingAreaCores, font->fid);
    XSetFont(display, gc_drawingAreaLog, font->fid);
    XSetFont(display, gc_drawingAreaAutoCorrelate, font->fid);
    XSetFont(display, gc_drawingAreaEvalCoreLogData, font->fid);
  }

  if(!(font = XLoadQueryFont(display, "-*-helvetica-*-r-*--10-*"))) {
    (void)printf("MakeTheGCs; drawing area font query failed\n");
  }
  else {
    XSetFont(display, gc_drawingAreaAdjustToTiesInfo, font->fid);
    XSetFont(display, gc_drawingAreaCorrelate, font->fid);
  }

  if(!(font = XLoadQueryFont(display, "-*-helvetica-*-r-*--8-*"))) {
    (void)printf("MakeTheGCs; drawing area font query failed\n");
  }
  else {
    XSetFont(display, gc_drawingAreaOptimizeTieCorrelate, font->fid);
    XSetFont(display, gc_drawingAreaSuggestLogDepthAdjustStats, font->fid);
  }
}

void MakeClipMask(dpy, gc, x, y, width, height)
Display *dpy;
GC gc;
short int x, y;
unsigned short int width, height;
{
  Region r;
  XRectangle rect;

  r = XCreateRegion();

  rect.x = x;
  rect.y = y;
  rect.width = width;
  rect.height = height;

  XUnionRectWithRegion(&rect, r, r);

  XSetRegion(dpy, gc, r);

  XDestroyRegion(r);
}

void SetInitialColors(dpy)
Display *dpy;
{
  XmString xmstring;
  XColor return_color, unused;
  Pixel pixwhite, pixblack;
  void CustomColorBackgroundChange(), CustomColorLabelChange();
  int GetColorSet();

  cmap = DefaultColormapOfScreen(XtScreen(drawingAreaCores));

  /* get black and white pixel values for backup incase have a
     failed named color allocation
  */
  pixblack = BlackPixelOfScreen(XtScreen(drawingAreaCores));
  pixwhite = WhitePixelOfScreen(XtScreen(drawingAreaCores));

  /* get the colorset to use
  */
  GetColorSet();

  /* set the background color for the four drawing areas 
  */
  if(!XAllocNamedColor(dpy, cmap, color[BG_COLOR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[BG_COLOR]); 
    SaManageWarningBox(buffer);
    bgPixel = pixblack; 
    xmstring = XmStringCreateSimple("black");
    XtVaSetValues(pushButtonColorBackground, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    bgPixel = return_color.pixel;
    xmstring = XmStringCreateSimple(color[BG_COLOR]);
    XtVaSetValues(pushButtonColorBackground, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }

  XtVaSetValues(drawingAreaCores, XmNbackground, bgPixel, NULL); 
  XtVaSetValues(drawingAreaLog, XmNbackground, bgPixel, NULL);
  XtVaSetValues(drawingAreaAdjustToTiesInfo, XmNbackground, bgPixel, NULL);
  XtVaSetValues(drawingAreaCorrelate, XmNbackground, bgPixel, NULL);
  XtVaSetValues(drawingAreaOptimizeTieCorrelate, XmNbackground, bgPixel, NULL);
  XtVaSetValues(drawingAreaSuggestLogDepthAdjustStats, XmNbackground, bgPixel, NULL);
  XtVaSetValues(drawingAreaAutoCorrelate, XmNbackground, bgPixel, NULL);
  XtVaSetValues(drawingAreaEvalCoreLogData, XmNbackground, bgPixel, NULL);

  /* set the border color of cursor location, core tie and log tie labels to 
     drawing areas background color
  */
  XtVaSetValues(labelCursorLocation, XmNborderColor, bgPixel, NULL);
  XtVaSetValues(labelLogTiePoint, XmNborderColor, bgPixel, NULL);

  /* set the color rowColumn and labels background 
     to the drawing areas background
  */
  CustomColorBackgroundChange(bgPixel);

  /* set all the foreground colors
     at the same time set colors for push buttons in custom color
  */

  /* the labels for all four drawing areas
  */
  if(!XAllocNamedColor(dpy, cmap, color[CLINE_LABEL], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_LABEL]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_LABEL] = pixwhite;
    xmstring = XmStringCreateSimple("white");
    XtVaSetValues(pushButtonColorLabels, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else { 
    fgPixel[CLINE_LABEL] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_LABEL]);
    XtVaSetValues(pushButtonColorLabels, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorLabels, XmNbackground, fgPixel[CLINE_LABEL], NULL);

  /* if no foreground and or background color were read on command line args
     set the colors for hsplicer foreground and background to the drawing
     args background and labels
  
  if(prgfg == NO || prgbg == NO) {
    (void)sprintf(prgfgcolor, "");
    (void)sprintf(prgfgcolor, color[CLINE_LABEL]);
    (void)sprintf(prgbgcolor, "");
    (void)sprintf(prgbgcolor, color[BG_COLOR]);
  }
*/

  /* set the foreground color for custom color labels and buttons
  */
  CustomColorLabelChange(fgPixel[CLINE_LABEL]);

  /* foreground colors for the core drawing area
  */
  if(!XAllocNamedColor(dpy, cmap, color[CLINE_COREODPSBD], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_COREODPSBD]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_COREODPSBD] = pixwhite;
    xmstring = XmStringCreateSimple("white");
    XtVaSetValues(pushButtonColorCore, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);   
  }  
  else {
    fgPixel[CLINE_COREODPSBD] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_COREODPSBD]);
    XtVaSetValues(pushButtonColorCore, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorCore, XmNbackground, fgPixel[CLINE_COREODPSBD], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[CLINE_COREMCD], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_COREMCD]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_COREODPSBD] = pixwhite;
    xmstring = XmStringCreateSimple("white");
    XtVaSetValues(pushButtonColorCoremcd, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[CLINE_COREMCD] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_COREMCD]);
    XtVaSetValues(pushButtonColorCoremcd, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorCoremcd, XmNbackground, fgPixel[CLINE_COREMCD], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[CLINE_CORESMOOTH], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_CORESMOOTH]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_CORESMOOTH] = pixwhite;
    xmstring = XmStringCreateSimple("white");
    XtVaSetValues(pushButtonColorCoreSmooth, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  } 
  else { 
    fgPixel[CLINE_CORESMOOTH] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_CORESMOOTH]);
    XtVaSetValues(pushButtonColorCoreSmooth, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorCoreSmooth, XmNbackground, fgPixel[CLINE_CORESMOOTH], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[CLINE_COREEQUIVLOGDEPTH], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_COREEQUIVLOGDEPTH]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_COREEQUIVLOGDEPTH] = pixwhite;
    xmstring = XmStringCreateSimple("white"); 
    XtVaSetValues(pushButtonColorCoreEquivLogDepth, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  } 
  else { 
    fgPixel[CLINE_COREEQUIVLOGDEPTH] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_COREEQUIVLOGDEPTH]); 
    XtVaSetValues(pushButtonColorCoreEquivLogDepth, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorCoreEquivLogDepth, XmNbackground, fgPixel[CLINE_COREEQUIVLOGDEPTH], NULL);

  /* foreground colors for the log drawing area
  */
  if(!XAllocNamedColor(dpy, cmap, color[CLINE_LOG], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_LOG]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_LOG] = pixwhite;
    xmstring = XmStringCreateSimple("white");  
    XtVaSetValues(pushButtonColorLogLog, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  } 
  else { 
    fgPixel[CLINE_LOG] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_LOG]);   
    XtVaSetValues(pushButtonColorLogLog, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorLogLog, XmNbackground, fgPixel[CLINE_LOG], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[CLINE_LOGSMOOTH], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_LOGSMOOTH]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_LOGSMOOTH] = pixwhite;
    xmstring = XmStringCreateSimple("white");   
    XtVaSetValues(pushButtonColorLogSmooth, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  } 
  else { 
    fgPixel[CLINE_LOGSMOOTH] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_LOGSMOOTH]);    
    XtVaSetValues(pushButtonColorLogSmooth, XmNlabelString, xmstring, NULL);  
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorLogSmooth, XmNbackground, fgPixel[CLINE_LOGSMOOTH], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[CLINE_LOGADJDEPTH], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_LOGADJDEPTH]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_LOGADJDEPTH] = pixwhite;
    xmstring = XmStringCreateSimple("white");    
    XtVaSetValues(pushButtonColorLogAdjust, XmNlabelString, xmstring, NULL);  
    XmStringFree(xmstring);
  } 
  else { 
    fgPixel[CLINE_LOGADJDEPTH] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_LOGADJDEPTH]);     
    XtVaSetValues(pushButtonColorLogAdjust, XmNlabelString, xmstring, NULL);   
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorLogAdjust, XmNbackground, fgPixel[CLINE_LOGADJDEPTH], NULL);

  /* tie points and tie lines
  */
  if(!XAllocNamedColor(dpy, cmap, color[CLINE_TIEPT1], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_TIEPT1]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_TIEPT1] = pixwhite;
    xmstring = XmStringCreateSimple("white");      
    XtVaSetValues(pushButtonColorTiePtCore, XmNlabelString, xmstring, NULL);    
    XmStringFree(xmstring);
  }  
  else {
    fgPixel[CLINE_TIEPT1] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_TIEPT1]);
    XtVaSetValues(pushButtonColorTiePtCore, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorTiePtCore, XmNbackground, fgPixel[CLINE_TIEPT1], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[CLINE_TIEPT2], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_TIEPT2]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_TIEPT2] = pixwhite;
    xmstring = XmStringCreateSimple("white");
    XtVaSetValues(pushButtonColorTiePtLog, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }  
  else {
    fgPixel[CLINE_TIEPT2] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_TIEPT2]); 
    XtVaSetValues(pushButtonColorTiePtLog, XmNlabelString, xmstring, NULL); 
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorTiePtLog, XmNbackground, fgPixel[CLINE_TIEPT2], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[CLINE_TIELINESADJUSTDONE], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_TIELINESADJUSTDONE]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_TIELINESADJUSTDONE] = pixwhite;  
    xmstring = XmStringCreateSimple("white");  
    XtVaSetValues(pushButtonColorTieAdjusted, XmNlabelString, xmstring, NULL);  
    XmStringFree(xmstring);
  } 
  else {
    fgPixel[CLINE_TIELINESADJUSTDONE] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_TIELINESADJUSTDONE]);   
    XtVaSetValues(pushButtonColorTieAdjusted, XmNlabelString, xmstring, NULL);   
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorTieAdjusted, XmNbackground, fgPixel[CLINE_TIELINESADJUSTDONE], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[CLINE_TIELINELAST], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_TIELINELAST]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_TIELINELAST] = pixwhite;
    xmstring = XmStringCreateSimple("white");   
    XtVaSetValues(pushButtonColorTieNew, XmNlabelString, xmstring, NULL);   
    XmStringFree(xmstring);
  }  
  else {
    fgPixel[CLINE_TIELINELAST] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_TIELINELAST]);    
    XtVaSetValues(pushButtonColorTieNew, XmNlabelString, xmstring, NULL);    
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorTieNew, XmNbackground, fgPixel[CLINE_TIELINELAST], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[CLINE_TIESELECT], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_TIESELECT]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_TIESELECT] = pixwhite;
    xmstring = XmStringCreateSimple("white");    
    XtVaSetValues(pushButtonColorTieSelected, XmNlabelString, xmstring, NULL);    
    XmStringFree(xmstring);
  }
  else {
    fgPixel[CLINE_TIESELECT] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_TIESELECT]);    
    XtVaSetValues(pushButtonColorTieSelected, XmNlabelString, xmstring, NULL);     
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorTieSelected, XmNbackground, fgPixel[CLINE_TIESELECT], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[CLINE_COREOVERLAYINCORR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_COREOVERLAYINCORR]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_COREOVERLAYINCORR] = pixwhite;
    xmstring = XmStringCreateSimple("white");    
    XtVaSetValues(pushButtonColorLogCoreOverlayInCorr, XmNlabelString, xmstring, NULL);     
    XmStringFree(xmstring);
  }
  else {
    fgPixel[CLINE_COREOVERLAYINCORR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_COREOVERLAYINCORR]);     
    XtVaSetValues(pushButtonColorLogCoreOverlayInCorr, XmNlabelString, xmstring, NULL);      
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorLogCoreOverlayInCorr, XmNbackground, fgPixel[CLINE_COREOVERLAYINCORR], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[CLINE_COREOVERLAYOUTCORR], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_COREOVERLAYOUTCORR]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_COREOVERLAYOUTCORR] = pixwhite;
    xmstring = XmStringCreateSimple("white");
    XtVaSetValues(pushButtonColorLogCoreOverlayOutCorr, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[CLINE_COREOVERLAYOUTCORR] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_COREOVERLAYOUTCORR]);
    XtVaSetValues(pushButtonColorLogCoreOverlayOutCorr, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorLogCoreOverlayOutCorr, XmNbackground, fgPixel[CLINE_COREOVERLAYOUTCORR], NULL);

  /* stratigraphy
  */
  if(!XAllocNamedColor(dpy, cmap, color[CLINE_PALEOMAG], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_PALEOMAG]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_PALEOMAG] = pixwhite;
    xmstring = XmStringCreateSimple("white");     
    XtVaSetValues(pushButtonColorStratPaleomag, XmNlabelString, xmstring, NULL);      
    XmStringFree(xmstring);
  }  
  else {
    fgPixel[CLINE_PALEOMAG] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_PALEOMAG]);     
    XtVaSetValues(pushButtonColorStratPaleomag, XmNlabelString, xmstring, NULL);       
    XmStringFree(xmstring);
  }  
  XtVaSetValues(pushButtonColorStratPaleomag, XmNbackground, fgPixel[CLINE_PALEOMAG], NULL);
 
  if(!XAllocNamedColor(dpy, cmap, color[CLINE_DIATOM], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color %s.",  color[CLINE_DIATOM]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_DIATOM] = pixwhite;
    xmstring = XmStringCreateSimple("white");     
    XtVaSetValues(pushButtonColorStratDiatom, XmNlabelString, xmstring, NULL);       
    XmStringFree(xmstring);
  }  
  else {
    fgPixel[CLINE_DIATOM] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_DIATOM]);      
    XtVaSetValues(pushButtonColorStratDiatom, XmNlabelString, xmstring, NULL);        
    XmStringFree(xmstring);
  }  
  XtVaSetValues(pushButtonColorStratDiatom, XmNbackground, fgPixel[CLINE_DIATOM], NULL);
 
  if(!XAllocNamedColor(dpy, cmap, color[CLINE_RAD], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_RAD]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_RAD] = pixwhite;
    xmstring = XmStringCreateSimple("white");      
    XtVaSetValues(pushButtonColorStratRad, XmNlabelString, xmstring, NULL);        
    XmStringFree(xmstring);
  }  
  else {
    fgPixel[CLINE_RAD] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_RAD]);       
    XtVaSetValues(pushButtonColorStratRad, XmNlabelString, xmstring, NULL);         
    XmStringFree(xmstring);
  }  
  XtVaSetValues(pushButtonColorStratRad, XmNbackground, fgPixel[CLINE_RAD], NULL);
     
  if(!XAllocNamedColor(dpy, cmap, color[CLINE_FORAM], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_FORAM]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_FORAM] = pixwhite;
    xmstring = XmStringCreateSimple("white");       
    XtVaSetValues(pushButtonColorStratForam, XmNlabelString, xmstring, NULL);         
    XmStringFree(xmstring);
  }  
  else {
    fgPixel[CLINE_FORAM] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_FORAM]);        
    XtVaSetValues(pushButtonColorStratForam, XmNlabelString, xmstring, NULL);         
    XmStringFree(xmstring);
  }  
  XtVaSetValues(pushButtonColorStratForam, XmNbackground, fgPixel[CLINE_FORAM], NULL);
     
  if(!XAllocNamedColor(dpy, cmap, color[CLINE_NANNO], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_NANNO]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_NANNO] = pixwhite;
    xmstring = XmStringCreateSimple("white");        
    XtVaSetValues(pushButtonColorStratNanno, XmNlabelString, xmstring, NULL);         
    XmStringFree(xmstring);
  }  
  else {
    fgPixel[CLINE_NANNO] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_NANNO]);         
    XtVaSetValues(pushButtonColorStratNanno, XmNlabelString, xmstring, NULL);          
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorStratNanno, XmNbackground, fgPixel[CLINE_NANNO], NULL);

  /* foreground colors for the correlation drawing area
  */
  if(!XAllocNamedColor(dpy, cmap, color[CLINE_CORRELATION], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_CORRELATION]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_CORRELATION] = pixwhite;
    xmstring = XmStringCreateSimple("white");         
    XtVaSetValues(pushButtonColorCorrelationCorrCoef, XmNlabelString, xmstring, NULL);          
    XmStringFree(xmstring);
  } 
  else { 
    fgPixel[CLINE_CORRELATION] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_CORRELATION]);         
    XtVaSetValues(pushButtonColorCorrelationCorrCoef, XmNlabelString, xmstring, NULL);           
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorCorrelationCorrCoef, XmNbackground, fgPixel[CLINE_CORRELATION], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[CLINE_CORRELATIONBEST], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_CORRELATIONBEST]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_CORRELATIONBEST] = pixwhite;
    xmstring = XmStringCreateSimple("white");         
    XtVaSetValues(pushButtonColorCorrelationBest, XmNlabelString, xmstring, NULL);           
    XmStringFree(xmstring);
  } 
  else { 
    fgPixel[CLINE_CORRELATIONBEST] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_CORRELATIONBEST]);          
    XtVaSetValues(pushButtonColorCorrelationBest, XmNlabelString, xmstring, NULL);            
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorCorrelationBest, XmNbackground, fgPixel[CLINE_CORRELATIONBEST], NULL);

  /* foreground colors for the adjust to ties evaluation drawing area
  */
  if(!XAllocNamedColor(dpy, cmap, color[CLINE_ADJUSTTOTIESSTATS], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_ADJUSTTOTIESSTATS]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_ADJUSTTOTIESSTATS] = pixwhite;
    xmstring = XmStringCreateSimple("white");          
    XtVaSetValues(pushButtonColorCoreAdjustStatsStats, XmNlabelString, xmstring, NULL);            
    XmStringFree(xmstring);
  } 
  else { 
    fgPixel[CLINE_ADJUSTTOTIESSTATS] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_ADJUSTTOTIESSTATS]);           
    XtVaSetValues(pushButtonColorCoreAdjustStatsStats, XmNlabelString, xmstring, NULL);             
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorCoreAdjustStatsStats, XmNbackground, fgPixel[CLINE_ADJUSTTOTIESSTATS], NULL);

  /* foreground colors for ancillary log data
  */
  if(!XAllocNamedColor(dpy, cmap, color[CLINE_ANCILLARY1], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_ANCILLARY1]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_ANCILLARY1] = pixwhite;
    xmstring = XmStringCreateSimple("white");
    XtVaSetValues(pushButtonColorAncillaryLog1, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[CLINE_ANCILLARY1] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_ANCILLARY1]);
    XtVaSetValues(pushButtonColorAncillaryLog1, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorAncillaryLog1, XmNbackground, fgPixel[CLINE_ANCILLARY1], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[CLINE_ANCILLARY2], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_ANCILLARY2]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_ANCILLARY2] = pixwhite;
    xmstring = XmStringCreateSimple("white");
    XtVaSetValues(pushButtonColorAncillaryLog2, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[CLINE_ANCILLARY2] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_ANCILLARY2]);
    XtVaSetValues(pushButtonColorAncillaryLog2, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorAncillaryLog2, XmNbackground, fgPixel[CLINE_ANCILLARY2], NULL);

  if(!XAllocNamedColor(dpy, cmap, color[CLINE_ANCILLARY3], &return_color, &unused)) {
    (void)sprintf(buffer, "can not allocate named color.  %s", color[CLINE_ANCILLARY3]);
    SaManageWarningBox(buffer);
    fgPixel[CLINE_ANCILLARY3] = pixwhite;
    xmstring = XmStringCreateSimple("white");
    XtVaSetValues(pushButtonColorAncillaryLog3, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  else {
    fgPixel[CLINE_ANCILLARY3] = return_color.pixel;
    xmstring = XmStringCreateSimple(color[CLINE_ANCILLARY3]);
    XtVaSetValues(pushButtonColorAncillaryLog3, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
  }
  XtVaSetValues(pushButtonColorAncillaryLog3, XmNbackground, fgPixel[CLINE_ANCILLARY3], NULL);
}


void DrawCores(w, dpy, xid, gc, clip, draw_line, line_y)
Widget w;
Display *dpy;
Window xid;
GC gc;
int clip, draw_line, line_y;
{

  int i, ii, j, jj, k, kk, n, tic, sm, start, foundtop, foundbot, depcull, pixpermeter, axispixlen,
      sx, sy, sdx, sdy, yoff, xoff, holdint, left, dum, err, ticpixlen, annot, label, scalemax, h, c;
  char s[50];
  float  unitinc, *pdat, dep, *dat, *sbd, flip_adj, flip_off,
         botoffset, topoffset, maxmeter, tieptval;
  double check, fract, ip;
  Dimension win_height, win_width;
  int InterpolateCoreTiePtValue();
 
  /* get the height and width of the drawing area
  */ 
  XtVaGetValues(w, XmNheight, &win_height, XmNwidth, &win_width, NULL);

  /* find the maximum length of the depth axis
     may only need to do this once when read data;
     then use either core or log max depending on which is bigger
  */
  if(have_cores == DO || have_splice == DO || have_log == DO || have_ancill == DO){
    check = maxdep/deptic;
    fract = modf(check, &ip);
    if(fract == 0.0){
      maxmeter = maxdep;
    }
    else {
      maxmeter = (ip * deptic) + deptic;
    }

    if(maxdep > maxmeter){
      while(maxdep > maxmeter){
        maxmeter = maxmeter + deptic;
      }  
    }
    scalemax = maxmeter;
    XtVaSetValues(scaleDrawingAreas, XmNmaximum, scalemax, NULL);
  }
  else {
    maxmeter = MAXDEP;
    check = maxmeter/deptic;
    fract = modf(check, &ip);
    if(fract == 0.0){
    }
    else {
      maxmeter = (ip * deptic) + deptic;
    }
    scalemax = maxmeter;
    XtVaSetValues(scaleDrawingAreas, XmNmaximum, scalemax, NULL);
  }
 
  /* get the vert. slider scale value which is the starting value of the y axis
  */
  XmScaleGetValue(scaleDrawingAreas, &scale_val);
 
  tic = deptic;                /*tic increment in meters*/
  top_meter = scale_val;  /*value at top off depth axis in meters*/
  if(top_meter == 0.0){
    top_off = OFF;        /*if 0.0 then give an offset from top of window*/
  }
  else {
    top_off = 0;
  }
 
 
  check = top_meter/deptic;
  fract = modf(check, &ip);       /* is the top value divisable by tic or is there a remainder*/
 
  if(fract == 0.0) {              /*if no remainder than y axis starts at a tic*/
    unitinc = top_meter;
  }
  else {                          /*there is a remainder so axis does not start at a tic*/
    unitinc = tic * ip + tic;     /*so the first tic is the next one down*/
  }
 
  axispixlen = (int)win_height - top_off;  /*pixel length of depth axis*/
 
  /* calculate how many pixels in a meter; truncate the result so mult.
     meters are equal to a pixel value that is a whole number
  */
  check = axispixlen/depmeterdisplayed;
  fract = modf(check, &ip);
  pixpermeter = ip;
 
  ticpixlen = pixpermeter * tic;
  check = pixpermeter;
  depperpix = 1.0/check;
 
  if(unitinc == top_meter){    /*if axis does not start at a tic calculate the distance*/
    left = 0;                       /*in pixels from top of axis to first tic*/
  }
  else {
    left = (unitinc - top_meter) * pixpermeter;
  }
 

  /*clear the drawing area
  */
  XClearWindow(dpy, xid);
 
  /* set color for axis and labels
  */
  XSetForeground(dpy, gc, fgPixel[CLINE_LABEL]);
  annot = 1;
  label = NO;
  AxisDep(w, dpy, xid, gc,
            maxmeter, top_off, left, ticpixlen, deptic, unitinc, depperpix, annot, label);
 
  /* if there is data stored plot it
  */
  if(have_cores == DO){
      
    varperpix = (maxvar - minvar)/varaxislen;
 
    /* if there is room label the holes
    */
    if(unitinc == 0.0 && top_off == OFF) {
      (void)sprintf(s, "leg %d  site %d", data[dset]->leg, data[dset]->site);
      XDrawString(dpy, xid, gc,
                      OFF+20, OFF-35, s, (int)strlen(s));
    }
     
    /* is the var axis to be inverted
    */
    if(data[dset]->flip == YES) {
      flip_adj = -1.0;
      flip_off = maxvar - minvar;
      (void)sprintf(s, "Invert");
    }
    else {
      flip_adj = 1.0;
      flip_off = 0.0;
      (void)sprintf(s, " ");
    }
    XDrawString(dpy, xid, gc, win_width - 40, win_height - 5, s, (int)strlen(s));

    /*note that CleanUpCore returns one core that has been
      culled of bad values 
    */
     
    /* get the cores scale value. it will be the array num of
       the first hole to plot. in other words; where to 'skip to'
    */
    XmScaleGetValue(scaleCores, &scale_val);
    if(scale_val >= data[dset]->numholes) {
      return;
    }
    for(ii=scale_val; ii<data[dset]->numholes; ++ii) {
 
      XSetForeground(dpy, gc, fgPixel[CLINE_LABEL]);
      xoff=OFF+ SPACE + (ii-scale_val) * (varaxislen+SPACE);
      if(unitinc == 0.0 && top_off == OFF) {
        (void)sprintf(s, "hole %c", data[dset]->holes[ii]->name);
        XDrawString(dpy, xid, gc,
                       xoff, OFF-10, s, (int)strlen(s));
      }
 
      for(jj=0; jj<data[dset]->holes[ii]->numcores; ++jj) {

        if((sbd=(float*)calloc(data[dset]->holes[ii]->core[jj]->numvalues,sizeof(float))) == NULL)
                                   SaBadMemAlloc("Sa");
        if((dat=(float*)calloc(data[dset]->holes[ii]->core[jj]->numvalues,sizeof(float))) == NULL)
                                   SaBadMemAlloc("Sa");
        /* if are plotting both the unsmoothed and smoothed
           plot the smoothed
        */
        if(data[dset]->holes[ii]->core[jj]->value[0]->quality == BAD_CORE_NUM){
        }
        else{
          if(smooth.method !=NONE && (smooth.plot == SMOOTH || smooth.plot == SMOOTHBOTH)){
            sm = YES;
            dum = 0;
            err = CleanUpCore(dset, ii, jj, sbd, dat, sm, &dum, data[dset]->holes[ii]->core[jj]->have_equil_log_depths);
            if(err > 0) {
            }
            else {
              if(smooth.plot == SMOOTHBOTH) {
                XSetForeground(dpy, gc, fgPixel[CLINE_CORESMOOTH]);
              }
              else if(data[dset]->holes[ii]->core[jj]->have_equil_log_depths == DO) {
                XSetForeground(dpy, gc, fgPixel[CLINE_COREEQUIVLOGDEPTH]);
              }
              else {
                if(data[dset]->holes[ii]->core[jj]->did_affine_offset == YES) {
                  XSetForeground(dpy, gc, fgPixel[CLINE_COREMCD]);
                }
                else {
                  XSetForeground(dpy, gc, fgPixel[CLINE_COREODPSBD]);
                }
              }
              start = 0;
              while(sbd[start] == BADPT && start < data[dset]->holes[ii]->core[jj]->numvalues-1) {
                ++start;
              }
              if(start < data[dset]->holes[ii]->core[jj]->numvalues-2) {
                sx = (flip_adj * (dat[start] - minvar) + flip_off)/varperpix + xoff;
                sy = (sbd[start] - top_meter)/depperpix + top_off;
                for(kk=start+1; kk<data[dset]->holes[ii]->core[jj]->numvalues; ++kk) {
                  if(sbd[kk] == BADPT) {
                  }
                  else {
                    sdx = (flip_adj * (dat[kk] - minvar) + flip_off)/varperpix+xoff;
                    sdy = (sbd[kk] - top_meter)/depperpix+top_off;
                    if(sy < top_off || sdy < top_off) {
                    }
                    else if(sy > (int)win_height) {
                      break;
                    }
                    else {
                      XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
                    }
                    sx = sdx;
                    sy = sdy;
                  }
                }
              }
            }
          }
        }
 
        /* plot the unsmoothed.
        */
	sm=NO;
        dum = 0;
 
        if(data[dset]->holes[ii]->core[jj]->value[0]->quality == BAD_CORE_NUM){
        }
        else {
          if(smooth.plot == UNSMOOTH || smooth.plot == SMOOTHBOTH) {
            err = CleanUpCore(dset, ii, jj, sbd, dat, sm, &dum, data[dset]->holes[ii]->core[jj]->have_equil_log_depths);
 
            if(err > 0) {
            }
            else {
              if(data[dset]->holes[ii]->core[jj]->have_equil_log_depths == DO) {
                XSetForeground(dpy, gc, fgPixel[CLINE_COREEQUIVLOGDEPTH]);
              }
              else {
                if(data[dset]->holes[ii]->core[jj]->did_affine_offset == YES) {
                  XSetForeground(dpy, gc, fgPixel[CLINE_COREMCD]);
                }
                else {
                  XSetForeground(dpy, gc, fgPixel[CLINE_COREODPSBD]);
                }
              }
              start = 0;
              while(sbd[start] == BADPT && start < data[dset]->holes[ii]->core[jj]->numvalues-1) {
                ++start;
              }
              if(start < data[dset]->holes[ii]->core[jj]->numvalues-2) {
                sx = (flip_adj * (dat[start] - minvar) + flip_off)/varperpix + xoff;
                sy = (sbd[start] - top_meter)/depperpix + top_off;
                for(kk=start+1; kk<data[dset]->holes[ii]->core[jj]->numvalues; ++kk) {
                  if(sbd[kk] == BADPT) {
                  }
                  else {
                    sdx = (flip_adj * (dat[kk] - minvar) + flip_off)/varperpix+xoff;
                    sdy = (sbd[kk] - top_meter)/depperpix+top_off;
                    if(sy < top_off || sdy < top_off) {
                    }
                    else if(sy > (int)win_height) {
                      break;
                    }
                    else {
                      XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
                    }
                    sx = sdx;
                    sy = sdy;
                  }
                }
              }
            }
          }
        }
        /* label the core
        */
        sx = xoff - 15;
        sy = sy - 5;
        (void)sprintf(s, "%d", data[dset]->holes[ii]->core[jj]->num);
        XDrawString(dpy, xid, gc, sx, sy, s, (int)strlen(s));

        /* if this core has a tie list mark where the ties are
        */
        if(smooth.method !=NONE && (smooth.plot == SMOOTH || smooth.plot == SMOOTHBOTH)){
          sm = YES;
        }
        else {
          sm = NO;
        }
        h = data[dset]->holes[ii]->map_hole_to_eqlogdepth;
        c = data[dset]->holes[ii]->core[jj]->map_core_to_eqlogdepth;
        if(h > -1 && c > -1) {
          if(eqlogdepth.hole[h]->core[c]->nties > 0) {
            XSetForeground(dpy, gc, fgPixel[CLINE_TIELINESADJUSTDONE]);
            for(i=0; i<eqlogdepth.hole[h]->core[c]->nties; ++i) {
              InterpolateCoreTiePtValue(dset, ii, jj, sm, eqlogdepth.hole[h]->core[c]->tie[i]->corembsf, &tieptval, &dum);
              sx = (flip_adj * (tieptval - minvar) + flip_off)/varperpix+xoff;
              sy = (eqlogdepth.hole[h]->core[c]->tie[i]->equivlogdep - top_meter)/depperpix+top_off;
              XDrawLine(dpy, xid, gc, sx - 5, sy, sx + 5, sy);
            }
          }
        }

        free(sbd);
        sbd = NULL;
        free(dat);
        dat = NULL;
      }
    }
  }
  else {
    varperpix = 1.0;
  }

  /* draw the stratigraphy if have any.
  */
  if(have_strat == DO && have_cores == DO){

    /* for each file(strat type) find out what type it
       is and set the color
    */
    for(ii=0; ii<strat_file_cnt; ++ii){
      if(strat[ii]->type == PALEOMAG){
        XSetForeground(XtDisplay(w), gc_drawingAreaCores, fgPixel[CLINE_PALEOMAG]);
      }
      else if(strat[ii]->type == DIATOMS){
        XSetForeground(XtDisplay(w), gc_drawingAreaCores, fgPixel[CLINE_DIATOM]);
      }
      else if(strat[ii]->type == RADIOLARIA){
        XSetForeground(XtDisplay(w), gc_drawingAreaCores, fgPixel[CLINE_RAD]);
      }
      else if(strat[ii]->type == FORAMINIFERA){
        XSetForeground(XtDisplay(w), gc_drawingAreaCores, fgPixel[CLINE_FORAM]);
      }
      else if(strat[ii]->type == NANNOFOSSILS){
        XSetForeground(XtDisplay(w), gc_drawingAreaCores, fgPixel[CLINE_NANNO]);
      }

      for(jj=0; jj<strat[ii]->data_cnt; ++jj){

        if(strat[ii]->data[jj].top.maptohole[dset] != -1) {
          sx = OFF + SPACE + 10 + (strat[ii]->data[jj].top.maptohole[dset]-scale_val) * (varaxislen+SPACE);;
          if(strat[ii]->autocorr_status == YES || strat[ii]->data[jj].top.did_eld == YES) {
            sy = (strat[ii]->data[jj].top.eld - top_meter)/depperpix + top_off;
          }
          else {
            sy = (strat[ii]->data[jj].top.mbsf + strat[ii]->data[jj].top.aff_offset - top_meter)/depperpix + top_off;
          }
          if(strat[ii]->autocorr_status == YES || strat[ii]->data[jj].top.did_eld == YES) {
            sdy = (strat[ii]->data[jj].bot.eld - top_meter)/depperpix + top_off;
          }
          else {
            sdy = (strat[ii]->data[jj].bot.mbsf + strat[ii]->data[jj].bot.aff_offset - top_meter)/depperpix + top_off;
          }
          if(sy > (int)win_height || sdy < 0) {
            strat[ii]->data[jj].x_pix_loc = -1;
            strat[ii]->data[jj].y_pix_loc = -1;
          }
          else if(sx < OFF) {
            strat[ii]->data[jj].x_pix_loc = -1;
            strat[ii]->data[jj].y_pix_loc = -1;
          }
          else {
            XDrawLine(XtDisplay(w), XtWindow(w), gc_drawingAreaCores,
                          sx-3, sy, sx+3, sy);
            XDrawLine(XtDisplay(w), XtWindow(w), gc_drawingAreaCores,
                          sx-3, sdy, sx+3, sdy);
            XDrawLine(XtDisplay(w), XtWindow(w), gc_drawingAreaCores,
                          sx, sy, sx, sdy);
            (void)sprintf(s, "%s", strat[ii]->data[jj].code);
            strat[ii]->data[jj].x_pix_loc = sx - 15;
            strat[ii]->data[jj].y_pix_loc = sy + (sdy-sy)/2;
            XDrawString(XtDisplay(w), XtWindow(w), gc_drawingAreaCores,
                     strat[ii]->data[jj].x_pix_loc, strat[ii]->data[jj].y_pix_loc, s, (int)strlen(s));
          }
        }
      }
    }
  }
  else {
  }

  if(draw_line == YES) {
    XSetForeground(dpy, gc, fgPixel[CLINE_LABEL]);
    sy = line_y;
    sx = OFF + SPACE;
    sdx = OFF + (data[dset]->numholes * (SPACE + varaxislen));
    XDrawLine(dpy, xid, gc, sx, sy, sdx, sy);
  }
}


void DrawLog(w, dpy, xid, gc, clip, autooff, only_draw_log)
Widget w;
Display *dpy;
Window xid;
GC gc;
int clip;
float autooff;
int   only_draw_log;
{

  /* if haven't read cores yet need to find scales and such
     also, will need to scale log var
     also will need to check max depth to be sure window
     and scroll are big enough
  */
  int i, j, k, l, start, current, sx, sy, sdx, sdy, sdxl, sdyl, xoff, err, sm, smlog, dum, n, pointsize, scale_val,
      hole, core, array, log, pos, have_tempties, h, c, count, *position, ntimes;
  char s[10];
  String str;
  float adj, logvarperpix, perpix, *sbd, *dat, tieptval, winlen, 
        flip_core_adj, flip_core_off, flip_log_adj, flip_log_off, squish;
  Dimension win_height, win_width;
  Ties   *tempties;
  int    GetTieListPosition(), MakeEquivLogDepthEquation(), CalcEquivLogDepths(), 
         InterpolateCoreTiePtValue(), InterpolateLogTiePtValue(), InterpolateSpliceTiePtValue();
  void MakeTempties();

  XtVaGetValues(w, XmNheight, &win_height, XmNwidth, &win_width, NULL);

  /*clear the drawing area
  */
  XClearWindow(dpy, xid);

  /* get the log scale value. it will conrol what will be
     plotted in window
  */
  XmScaleGetValue(scaleLog, &scale_val);

  current = 0;
  if(have_log == DO) {
    logvarperpix = (maxlog - minlog)/logaxislen;
    if(scale_val == 1) {
      xoff = 0;
    }
    else {
      xoff = 2 * logaxislen;
    }
    if(autocoreadj.draw_results == YES) {
      flip_log_adj = 1.0;
      flip_log_off = 0.0;
      (void)sprintf(s, " ");
    }
    else if(logdata[lset]->flip == YES) {
      flip_log_adj = -1.0;
      flip_log_off = maxlog - minlog;
      (void)sprintf(s, "Invert");
    }
    else {
      flip_log_adj = 1.0;
      flip_log_off = 0.0;
      (void)sprintf(s, " ");
    }
    XSetForeground(dpy, gc, fgPixel[CLINE_LABEL]);
    XDrawString(dpy, xid, gc, win_width - 40, win_height - 5, s, (int)strlen(s));

    /* if autocorr has been done get the log offset from the text widget
    */
    if(autocoreadj.draw_results == YES) {
      str = XmTextGetString(textFieldAutoCorrResultOffset);
      autooff = atof(str);
      XtFree(str);
    }

    /* if have smoothed the log plot smoothed
    */
    if(logdata[lset]->info.smooth.method == GAUSSIAN && logdata[lset]->info.smooth.plot == SMOOTH || logdata[lset]->info.smooth.plot == SMOOTHBOTH){
      if(logdata[lset]->info.smooth.plot == SMOOTHBOTH) {
        XSetForeground(dpy, gc, fgPixel[CLINE_LOGSMOOTH]);
      }
      else {
        if(eqlogdepth.did_log_mudline_adj == YES) {
          XSetForeground(dpy, gc, fgPixel[CLINE_LOGADJDEPTH]);
        }
        else {
          XSetForeground(dpy, gc, fgPixel[CLINE_LOG]);
        }
      }
      k = 0;
      while((logdata[lset]->value[k]->data == logdata[lset]->info.missing_value || logdata[lset]->value[k]->quality != GOOD) && 
              k < logdata[lset]->data_num) {
        ++k;
      }
      sx = (flip_log_adj * (logdata[lset]->value[k]->sm_data - minlog) + flip_log_off)/logvarperpix + xoff;
      sy = (logdata[lset]->value[k]->depth + autooff - top_meter)/depperpix + top_off;
      for(i=k+1; i<logdata[lset]->data_num; ++i) {
        if(logdata[lset]->value[i]->data == logdata[lset]->info.missing_value) {
        }
        else if(logdata[lset]->value[i]->quality != GOOD) {
        }
        else {
          sdx = (flip_log_adj * (logdata[lset]->value[i]->sm_data - minlog) + flip_log_off)/logvarperpix + xoff;
          sdy = (logdata[lset]->value[i]->depth + autooff - top_meter)/depperpix + top_off;
          if(sdy < top_off) {
          }
          else if(sy > (int)win_height) {
            break;
          }
          else {
            XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
          }
          sx = sdx;
          sy = sdy;
        }
      }
    }

    /* plot the unsmoothed log
    */
    if(logdata[lset]->info.smooth.plot == UNSMOOTH || logdata[lset]->info.smooth.plot == SMOOTHBOTH) {
      if(eqlogdepth.did_log_mudline_adj == YES) {
        XSetForeground(dpy, gc, fgPixel[CLINE_LOGADJDEPTH]);
      }
      else {
        XSetForeground(dpy, gc, fgPixel[CLINE_LOG]);
      }
      k = 0;
      while((logdata[lset]->value[k]->data == logdata[lset]->info.missing_value || logdata[lset]->value[k]->quality != GOOD) && 
              k < logdata[lset]->data_num) {
        ++k;
      }
      sx = (flip_log_adj * (logdata[lset]->value[k]->data - minlog) + flip_log_off)/logvarperpix + xoff; 
      sy = (logdata[lset]->value[k]->depth + autooff - top_meter)/depperpix + top_off;
      for(i=k+1; i<logdata[lset]->data_num; ++i) {
        if(logdata[lset]->value[i]->data == logdata[lset]->info.missing_value) {
        }
        else if(logdata[lset]->value[i]->quality != GOOD) {
        }
        else {
          sdx = (flip_log_adj * (logdata[lset]->value[i]->data - minlog) + flip_log_off)/logvarperpix + xoff;
          sdy = (logdata[lset]->value[i]->depth + autooff - top_meter)/depperpix + top_off;
          if(sdy < top_off) {
          }  
          else if(sy > (int)win_height) {
            break;
          }  
          else {
            XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
          }  
          sx = sdx;
          sy = sdy;
        }
      }
    }

    if(only_draw_log == YES) {
      return;
    }

    /* if have autocore results draw the core series at specified offset and squish
       next to and over log
    */
    if(autocoreadj.draw_results == YES && (have_cores == DO || (have_splice == DO && sset >= 0 && sset < splice_cnt))) {
      /* get the selected hole(s) from the list
      */
      if(!XmListGetSelectedPos(listAutoCorrHoleSelect, &position, &count)) {
        (void)sprintf(buffer, "Error: no hole(s) selected.");
        SaManageWarningBox(buffer);
        return;
      }
      if(count < 1) {
        (void)sprintf(buffer, "Error: no hole selected.");
        SaManageWarningBox(buffer);
        XtFree(position);
        return;
      }
      else if(have_splice == DONT && have_cores == DO) {
        if(count > data[dset]->numholes) {
          (void)sprintf(buffer, "Error: hole selection exceeds number of holes!?.");
          SaManageWarningBox(buffer);
          XtFree(position);
          return;
        }
      }
      if(XmToggleButtonGetState(toggleButtonAutoCorrelateFlipYes) == True) {
        flip_core_adj = -1.0;
        if(have_splice == DO) {
          flip_core_off = splice[sset]->max - splice[sset]->min;
        }
        else {
          flip_core_off = maxvar - minvar;
        }
      }
      else {
        flip_core_adj = 1.0;
        flip_core_off = 0.0;
      }
      str = XmTextGetString(textFieldAutoCorrResultSquish);
      squish = atof(str);
      XtFree(str);
      if(squish <= MIN_SQUISH || squish > MAX_STRETCH) {
        return;
      }
      squish = squish/100.0;
      perpix = (maxvar - minvar)/logaxislen;
      xoff = 2 * logaxislen;
      if(smooth.method != NONE && (smooth.plot == SMOOTH || smooth.plot == SMOOTHBOTH)) {
        sm = YES;
      }
      else {
        sm = NO;
      }
      dum = 0;
      for(i=0; i<count; ++i) {
        h = position[i] - 1;
        if(have_splice == DO) {
          XSetForeground(dpy, gc, fgPixel[CLINE_COREOVERLAYINCORR]);
          start = 0;
          while(splice[sset]->value[start]->quality != GOOD && start < splice[sset]->numvalues-1) {
            ++start;
          }
          if(start < splice[sset]->numvalues-2) {
            if(sm == YES) {
              sx = (flip_core_adj * (splice[sset]->value[start]->sm_data - splice[sset]->min) + flip_core_off)/perpix + xoff;
            }
            else {
              sx = (flip_core_adj * (splice[sset]->value[start]->data - splice[sset]->min) + flip_core_off)/perpix + xoff;
            }
            sy = ((splice[sset]->value[start]->mcd * squish) - top_meter)/depperpix + top_off;
            for(j=start + 1; j<splice[sset]->numvalues; ++j) {
              if(splice[sset]->value[j]->quality != GOOD) {
              }
              else {
                if(sm == YES) {
                  sdx = (flip_core_adj * (splice[sset]->value[j]->sm_data - splice[sset]->min) + flip_core_off)/perpix + xoff;
                }
                else {
                  sdx = (flip_core_adj * (splice[sset]->value[j]->data - splice[sset]->min) + flip_core_off)/perpix + xoff;
                }
                sdy = ((splice[sset]->value[j]->mcd * squish) - top_meter)/depperpix + top_off;
                if(sdy < top_off) {
                }
                else if(sy > (int)win_height) {
                  break;
                }
                else {
                  XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
                }
                sx = sdx;
                sy = sdy;
              }
            }
          }
        }
        else {
          for(j=0; j<data[dset]->holes[h]->numcores; ++j) {
            if(have_affine == DO && data[dset]->holes[h]->core[j]->did_affine_offset == YES) {
              XSetForeground(dpy, gc, fgPixel[CLINE_COREOVERLAYINCORR]);
            }
            else {
              XSetForeground(dpy, gc, fgPixel[CLINE_COREOVERLAYOUTCORR]);
            }
            if((sbd=(float*)calloc(data[dset]->holes[h]->core[j]->numvalues,sizeof(float))) == NULL)
                                    SaBadMemAlloc("Sa");
            if((dat=(float*)calloc(data[dset]->holes[h]->core[j]->numvalues,sizeof(float))) == NULL)
                                    SaBadMemAlloc("Sa");
            err = CleanUpCore(dset, h, j, sbd, dat, sm, &dum, NO);
            if(err > 0) {
            }
            else {
              start = 0;
              while(sbd[start] == BADPT && start < data[dset]->holes[h]->core[j]->numvalues-1) {
                ++start;
              }
              if(start < data[dset]->holes[h]->core[j]->numvalues-2) {
                sx = (flip_core_adj * (dat[start] - minvar) + flip_core_off)/perpix + xoff;
                sy = ((sbd[start] * squish) - top_meter)/depperpix + top_off;
                for(k=start+1; k<data[dset]->holes[h]->core[j]->numvalues; ++k) {
                  if(sbd[k] == BADPT) {
                  }
                  else {
                    sdx = (flip_core_adj * (dat[k] - minvar) + flip_core_off)/perpix+xoff;
                    sdy = ((sbd[k] * squish) - top_meter)/depperpix+top_off;
                    if(sy < top_off || sdy < top_off) {
                    }
                    else if(sy > (int)win_height) {
                      break;
                    }
                    else {
                      XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
                    }
                    sx = sdx;
                    sy = sdy;
                  }
                }
              }
              else {
              }
            }

            free(sbd);
            sbd = NULL;
            free(dat);
            dat = NULL;
          }
        }
      }
      XtFree(position);
      return;
    } 
  }

  /* if have a selected core, draw it
  */
  if(((have_coretotie == DO && missing_coretotie == NO) || have_splice == DO) && scale_val == 0) {

    if(data[dset]->flip == YES) {
      flip_core_adj = -1.0; 
      if(have_splice == DO) {
        flip_core_off = splice[sset]->max - splice[sset]->min;
      }
      else {
        flip_core_off = maxvar - minvar;
      }
    }
    else {
      flip_core_adj = 1.0;
      flip_core_off = 0.0;
    }

    perpix = (maxvar - minvar)/logaxislen;
    xoff = 0;

    /* plot to orig core depth in left part of window
       then plot to temp equiv log depth in middle of window and
       then as an overlay of log
    */

    /* if have a tie list and  have a new tie (not yet in list) 
       create a temp list of tie list and new tie to use for calc eq log depths
       in log overlay
    */
    have_tempties = DONT;
    if(ties->nties > 0 && have_tie1 == DO && have_tie2 == DO) {
      /* alloc space for temp tie list. make it one bigger to account for
         current tie.
         note that will not be using temp_equiv_log_depths so don't need
         to allocate space for them
      */
      if((tempties=(Ties*)calloc(1,sizeof(Ties)))==NULL)
                              SaBadMemAlloc("Sa");
      if(have_tie1 == DO && have_tie2 == DO) {
        if((tempties->tie=(TieList**)calloc(ties->nties+1,sizeof(TieList*)))==NULL)
                              SaBadMemAlloc("Sa");
        for(i=0; i<=ties->nties; ++i) {
          if((tempties->tie[i]=(TieList*)calloc(1,sizeof(TieList)))==NULL)
                              SaBadMemAlloc("Sa");
        }
      }
      else {
        if((tempties->tie=(TieList**)calloc(ties->nties,sizeof(TieList*)))==NULL)
                              SaBadMemAlloc("Sa");
        for(i=0; i<ties->nties; ++i) {
          if((tempties->tie[i]=(TieList*)calloc(1,sizeof(TieList)))==NULL)
                              SaBadMemAlloc("Sa");
        }
      }
      MakeTempties(tempties);
      have_tempties = DO;
      if(have_tie1 == DO && have_tie2 == DO) {
        err = GetTieListPosition(YES, dset, &pos, tempties);
      }
      MakeEquivLogDepthEquation(tempties);
    }

    if(have_coretotie == DO) {

      if((sbd=(float*)calloc(data[dset]->holes[ties->hole]->core[ties->core]->numvalues,sizeof(float))) == NULL)
                                SaBadMemAlloc("Sa");
      if((dat=(float*)calloc(data[dset]->holes[ties->hole]->core[ties->core]->numvalues,sizeof(float))) == NULL)
                                SaBadMemAlloc("Sa");

      for(i=1; i<=3; ++i) {

        /* eqlog says what depths to get in CleanUpCore. The core on left will be
           orig. depths(mbsf or mcd). the middle and right core will be eld. 
           the middle core will be adjusted to saved ties and
           the core on the right will be adjusted to saved ties and the current tie if have one
           note that the middle and right core may also have stretch/squish (and offset)
           from auto core adj
        */
        if(i == 1) {
          eqlog = NO;
        }
        else if(i == 2) {
          eqlog = TEMP;
        }
        else if(i == 3) {
          if(have_tie1 == DO && have_tie2 == DO) {
            /* will recalc. eld to include current tie so get orig. depths */
            if(eqlogdepth.autocorr_status == YES) {
              eqlog = AUTO;
            }
            else {
              eqlog = NO;
            }
            /* get the correlation window length
            */
            str= XmTextGetString(textFieldWindowLength);
            winlen = atof(str);
            XtFree(str);
          }
          else {
            eqlog = TEMP;
          }
        }

        /* if have smoothed the core data, plot the smoothed
        */
        if(smooth.method != NONE && (smooth.plot == SMOOTH || smooth.plot == SMOOTHBOTH)) {
          sm = YES;
          dum = 0;
          err = CleanUpCore(dset, ties->hole, ties->core, sbd, dat, sm, &dum, eqlog);
          if(err > 0) {
          }
          else {
            if(smooth.plot == SMOOTHBOTH) {
              XSetForeground(dpy, gc, fgPixel[CLINE_CORESMOOTH]);
            }
            else {
              if(i == 1) {
                if(data[dset]->holes[ties->hole]->core[ties->core]->did_affine_offset == YES) {
                  XSetForeground(dpy, gc, fgPixel[CLINE_COREMCD]);
                }
                else {
                  XSetForeground(dpy, gc, fgPixel[CLINE_COREODPSBD]);
                }
              }
              else if(i == 2) {
                XSetForeground(dpy, gc, fgPixel[CLINE_COREEQUIVLOGDEPTH]);
              }
              else if(i == 3) {
                XSetForeground(dpy, gc, fgPixel[CLINE_COREOVERLAYINCORR]);
              }
            }
            if(i < 3) {
              adj = 0.0;
            }
            else if(i == 3) {
              /* if have ties in list then tempties includes them and current tie if have it
                 so calc resulting eld
              */
              if(ties->nties > 0 && have_tie1 == DO && have_tie2 == DO) {
                err = CalcEquivLogDepths(data[dset]->holes[ties->hole]->core[ties->core]->numvalues, sbd, tempties); 
                adj = 0.0;
              }
              /* if don't have ties but have the current tie adj depths by resulting offset
              */
              else if(have_tie1 == DO && have_tie2 == DO) {
                if(eqlogdepth.autocorr_status == YES) {
                  adj = ties->tielogdep - ties->tiecoreautoeld;
                }
                else if(have_affine == DO) {
                  adj = ties->tielogdep - ties->tiecoremcd;
                }
                else {
                  adj = ties->tielogdep - ties->tiecorembsf;
                }
              }
              else {
                adj = 0.0;
              }
            }
            start = 0;
            while(sbd[start] == BADPT && start < data[dset]->holes[ties->hole]->core[ties->core]->numvalues-1) {
              ++start;
            }
            if(start < data[dset]->holes[ties->hole]->core[ties->core]->numvalues-2) {
              sx = (flip_core_adj * (dat[start] - minvar) + flip_core_off)/perpix + xoff;
              sy = (sbd[start] - top_meter + adj)/depperpix + top_off;
              for(k=start+1; k<data[dset]->holes[ties->hole]->core[ties->core]->numvalues; ++k) {
                if(sbd[k] == BADPT) {
                }
                else {
                  sdx = (flip_core_adj * (dat[k] - minvar) + flip_core_off)/perpix+xoff;
                  sdy = (sbd[k] - top_meter + adj)/depperpix+top_off;
                  if(sy < top_off || sdy < top_off) {
                  }
                  else if(sy > (int)win_height) {
                    break;
                  }
                  else {
                    if(i == 3 && have_tie1 == DO && have_tie2 == DO && ties->coretie > -1) {
                      if(sbd[k] >= sbd[ties->coretie] - winlen && sbd[k] <= sbd[ties->coretie] + winlen){
                        XSetForeground(dpy, gc, fgPixel[CLINE_COREOVERLAYINCORR]);
                      }
                      else {
                        XSetForeground(dpy, gc, fgPixel[CLINE_COREOVERLAYOUTCORR]);
                      }
                    }
                    else if(i == 3) {
                      XSetForeground(dpy, gc, fgPixel[CLINE_COREOVERLAYOUTCORR]);
                    }
                    XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
                  }
                  sx = sdx;
                  sy = sdy;
                }
              }
            }
            else {
            }
          }
        }

        /* plot the unsmoothed core data
        */
        if(smooth.plot == UNSMOOTH || smooth.plot == SMOOTHBOTH) {
          sm = NO;
          dum = 0;
          err = CleanUpCore(dset, ties->hole, ties->core, sbd, dat, sm, &dum, eqlog);
          if(err > 0) {
          }
          else {
            if(i == 1) {
              if(data[dset]->holes[ties->hole]->core[ties->core]->did_affine_offset == YES) {
                  XSetForeground(dpy, gc, fgPixel[CLINE_COREMCD]);
              }
              else {
                XSetForeground(dpy, gc, fgPixel[CLINE_COREODPSBD]);
              }
              adj = 0.0;
            }
            else if(i == 2) {
              XSetForeground(dpy, gc, fgPixel[CLINE_COREEQUIVLOGDEPTH]);
              adj = 0.0;
            }
            else if(i == 3) {
              XSetForeground(dpy, gc, fgPixel[CLINE_COREOVERLAYINCORR]);
              if(ties->nties > 0 && have_tie1 == DO && have_tie2 == DO) {
                err = CalcEquivLogDepths(data[dset]->holes[ties->hole]->core[ties->core]->numvalues, sbd, tempties); 
                adj = 0.0;
              }
              else if(have_tie1 == DO && have_tie2 == DO) {
                if(eqlogdepth.autocorr_status == YES) {
                  adj = ties->tielogdep - ties->tiecoreautoeld;
                }
                else if(have_affine == DO) {
                  adj = ties->tielogdep - ties->tiecoremcd;
                }
                else {
                  adj = ties->tielogdep - ties->tiecorembsf;
                }
              }
              else {
                adj = 0.0;
              }
            }
            start = 0;
            while(sbd[start] == BADPT && start < data[dset]->holes[ties->hole]->core[ties->core]->numvalues-1) {
              ++start;
            }
            if(start < data[dset]->holes[ties->hole]->core[ties->core]->numvalues-2) {
              sx = (flip_core_adj * (dat[start] - minvar) + flip_core_off)/perpix + xoff;
              sy = (sbd[start] - top_meter + adj)/depperpix + top_off;
              for(k=start+1; k<data[dset]->holes[ties->hole]->core[ties->core]->numvalues; ++k) {
                if(sbd[k] == BADPT) {
                }
                else {
                  sdx = (flip_core_adj * (dat[k] - minvar) + flip_core_off)/perpix+xoff;
                  sdy = (sbd[k] - top_meter + adj)/depperpix+top_off;
                  if(sy < top_off || sdy < top_off) {
                  }
                  else if(sy > (int)win_height) {
                    break;
                  }
                  else {
                    if(i == 3 && have_tie1 == DO && have_tie2 == DO && ties->coretie > -1) {
                      if(sbd[k] >= sbd[ties->coretie] - winlen && sbd[k] <= sbd[ties->coretie] + winlen){
                        XSetForeground(dpy, gc, fgPixel[CLINE_COREOVERLAYINCORR]);
                      }
                      else {
                        XSetForeground(dpy, gc, fgPixel[CLINE_COREOVERLAYOUTCORR]);
                      }
                    }
                    else if(i == 3) {
                      XSetForeground(dpy, gc, fgPixel[CLINE_COREOVERLAYOUTCORR]);
                    }
                    XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
                  }
                  sx = sdx;
                  sy = sdy;
                }
              }
            }
            else {
            }
          }
        }

        xoff = (i * logaxislen);

        /* label the core
        */
        if(i == 1) {
          XSetForeground(dpy, gc, fgPixel[CLINE_LABEL]);
          (void)sprintf(s,"hole %c  core %d", data[dset]->holes[ties->hole]->name, 
                         data[dset]->holes[ties->hole]->core[ties->core]->num);
          XDrawString(dpy, xid, gc, SPACE, (int)win_height - 20, s, (int)strlen(s));
        }
      }

      free(sbd);
      sbd = NULL;
      free(dat);
      dat = NULL;
    }

    else if(have_splice == DO && sset >= 0 && sset < splice_cnt) {
      adj = 0.0;
      if(have_log == DONT) {
        n = 2;
      }
      else if(XtIsManaged(formAutoCorrelate)) {
        n = 2;
      }
      else {
        n = 3;
      }
      for(i=1; i<=n; ++i) {
        if(i == 1) {
          xoff = 0;
        }
        else if(i == 2) {
        }
        else if(i == 3) {
          if((sbd=(float*)calloc(splice[sset]->numvalues,sizeof(float))) == NULL)
                                SaBadMemAlloc("Sa");

          /* if have ties in list then tempties includes them and current tie if have it
             so calc resulting eld
          */
          if(ties->nties > 0 && have_tie1 == DO && have_tie2 == DO) {
            for(j=0; j<splice[sset]->numvalues; ++j) {
              sbd[j] = splice[sset]->value[j]->mcd;
            }
            if(eqlogdepth.autocorr_status == YES) {
              ApplyCoreAdjustToOneCore(sbd, splice[sset]->numvalues);
            }
            err = CalcEquivLogDepths(splice[sset]->numvalues, sbd, tempties);
            adj = 0.0;
          }
          /* if don't have ties but have the current tie adj depths by resulting offset
          */
          else if(have_tie1 == DO && have_tie2 == DO) {
            for(j=0; j<splice[sset]->numvalues; ++j) {
              sbd[j] = ties->temp_equivlogdep[j];
            }
            if(eqlogdepth.autocorr_status == YES) {
              adj = ties->tielogdep - ties->tiecoreautoeld;
            }
            else {
              adj = ties->tielogdep - ties->tiecoremcd;
            }
          }
          else {
            for(j=0; j<splice[sset]->numvalues; ++j) {
              sbd[j] = ties->temp_equivlogdep[j];
            }
            adj = 0.0;
          }
        }

        /* plot 
        */
        if(smooth.method == NONE || smooth.plot == UNSMOOTH) {
          sm = NO;
          ntimes = 1;
        }
        else if(smooth.method != NONE && smooth.plot == SMOOTH) {
          sm = YES;
          ntimes = 1;
        }
        else if(smooth.method != NONE && smooth.plot == SMOOTHBOTH) {
          sm = YES;
          ntimes = 2;
        }
        for(l=0; l<ntimes; ++l) {
          if(smooth.plot == SMOOTHBOTH && sm == YES) {
            XSetForeground(dpy, gc, fgPixel[CLINE_CORESMOOTH]);
          }
          else if(i == 1) {
            XSetForeground(dpy, gc, fgPixel[CLINE_COREMCD]);
            xoff = 0;
          }
          else if(i == 2) {
            XSetForeground(dpy, gc, fgPixel[CLINE_COREEQUIVLOGDEPTH]);
          }
          else if(i == 3) {
            XSetForeground(dpy, gc, fgPixel[CLINE_COREOVERLAYINCORR]);
          }

          start = 0;
          while(splice[sset]->value[start]->quality != GOOD && start < splice[sset]->numvalues-1) {
            ++start;
          }
          if(start < splice[sset]->numvalues-2) {
            if(sm == YES) {
              sx = (flip_core_adj * (splice[sset]->value[start]->sm_data - splice[sset]->min) + flip_core_off)/perpix + xoff;
            }
            else {
              sx = (flip_core_adj * (splice[sset]->value[start]->data - splice[sset]->min) + flip_core_off)/perpix + xoff;
            }
            if(i == 1) {
              sy = (splice[sset]->value[start]->mcd - top_meter + adj)/depperpix + top_off;
            }
            else if(i == 2) {
              sy = (ties->temp_equivlogdep[start] - top_meter + adj)/depperpix + top_off;
            }
            else if(i = 3) {
              sy = (sbd[start] - top_meter + adj)/depperpix + top_off;
              if(have_tie1 == DO && have_tie2 == DO) {
                /* get the correlation window length
                */
                str= XmTextGetString(textFieldWindowLength);
                winlen = atof(str);
                XtFree(str);
              }
            }
            for(j=start + 1; j<splice[sset]->numvalues; ++j) {
              if(splice[sset]->value[j]->quality != GOOD) {
              }
              else {
                if(sm == YES) {
                  sdx = (flip_core_adj * (splice[sset]->value[j]->sm_data - splice[sset]->min) + flip_core_off)/perpix + xoff;
                }
                else {
                  sdx = (flip_core_adj * (splice[sset]->value[j]->data - splice[sset]->min) + flip_core_off)/perpix + xoff;
                }
                if(i == 1) {
                  sdy = (splice[sset]->value[j]->mcd - top_meter + adj)/depperpix + top_off;
                }
                else if(i == 2) {
                  sdy = (ties->temp_equivlogdep[j] - top_meter + adj)/depperpix + top_off; 
                }
                else if(i = 3) {
                  sdy = (sbd[j] - top_meter + adj)/depperpix + top_off;
                }
                if(sdy < top_off) {
                }
                else if(sy > (int)win_height) {
                  break;
                }
                else {
                  if(i == 3 && have_tie1 == DO && have_tie2 == DO && ties->coretie > -1) {
                    if(ties->temp_equivlogdep[j] >= ties->temp_equivlogdep[ties->coretie] - winlen && 
                       ties->temp_equivlogdep[j] <= ties->temp_equivlogdep[ties->coretie] + winlen){
                      XSetForeground(dpy, gc, fgPixel[CLINE_COREOVERLAYINCORR]);
                    }
                    else {
                      XSetForeground(dpy, gc, fgPixel[CLINE_COREOVERLAYOUTCORR]);
                    }
                  }
                  else if(i == 3) {
                    XSetForeground(dpy, gc, fgPixel[CLINE_COREOVERLAYOUTCORR]);
                  }
                  XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
                }
                sx = sdx;
                sy = sdy;
              }
            }
          }
          sm = NO;
        }

        xoff = (i * logaxislen);
        if(i == 3) {
          free(sbd);
          sbd = NULL;
        }
      }
      /* mark where the splices are
      */
      xoff = 0;
      XSetForeground(dpy, gc, fgPixel[CLINE_CORRELATIONBEST]);
      for(j=0; j<splice[sset]->numvalues-1; ++j) {
        if((splice[sset]->value[j]->hole != splice[sset]->value[j+1]->hole) ||
           (splice[sset]->value[j]->corename != splice[sset]->value[j+1]->corename)) {
          sdy = ((splice[sset]->value[j]->mcd + splice[sset]->value[j+1]->mcd)/2.0 - top_meter + adj)/depperpix + top_off;
          XDrawLine(dpy, xid, gc, xoff, sdy, xoff+30, sdy);
        }
      }
    }

    if(have_tempties == DO) {
      if(tempties) {
        if(tempties->nties > 0) {
          for(i=0; i<tempties->nties; ++i) {
            if(tempties->tie[i]) {
              free(tempties->tie[i]);
              tempties->tie[i] = NULL;
            }
          }
        }
        if(tempties->tie) {
          free(tempties->tie);
          tempties->tie = NULL;
        }
        free(tempties);
        tempties = NULL;
      }
    }

    if(smooth.method == GAUSSIAN && (smooth.plot == SMOOTH || smooth.plot == SMOOTHBOTH)) {
      sm = YES;
    }
    else {
      sm = NO;
    }

    /* tie points
    */
    if(have_tie1 == DO) {

      xoff = 0;
      dum = 0;
      if(sm == YES) {
        if(ties->coretie != -1) {
          if(have_coretotie == DO) {
            sx = (flip_core_adj * (data[dset]->holes[ties->hole]->core[ties->core]->value[ties->coretie]->sm_data - minvar) + flip_core_off)/perpix + xoff;
          }
          else if(have_splice == DO && (sset >= 0 && sset < splice_cnt)) {
            sx = (flip_core_adj * (splice[sset]->value[ties->coretie]->sm_data - splice[sset]->min) + flip_core_off)/perpix + xoff;
          }
          else {
            sx = 0;
          }
        }
        else {
          if(have_coretotie == DO) {
            err = InterpolateCoreTiePtValue(dset, ties->hole, ties->core, sm, ties->tiecorembsf, &tieptval, &dum);
            if(err > 0) {
              sx = xoff;
            }
            else {
              sx = (flip_core_adj * (tieptval - minvar) + flip_core_off)/perpix + xoff;
            }
          }
          else if(have_splice == DO) {
            err = InterpolateSpliceTiePtValue(sset, sm, ties->tiecoremcd, &tieptval, &dum);
            if(err > 0) {
              sx = xoff;
            }
            else {
              sx = (flip_core_adj * (tieptval - splice[sset]->min) + flip_core_off)/perpix + xoff;
            }
          }
        }
      } 
      else {
        if(ties->coretie != -1) {
          if(have_coretotie == DO) {
            sx = (flip_core_adj * (*data[dset]->holes[ties->hole]->core[ties->core]->value[ties->coretie]->data - minvar) + flip_core_off)/perpix + xoff;
          }
          else if(have_splice == DO && sset >= 0 && sset < splice_cnt) {
            sx = (flip_core_adj * (splice[sset]->value[ties->coretie]->data - splice[sset]->min) + flip_core_off)/perpix + xoff;
          }
          else {
            sx = 0;
          }
        }
        else {
          sm = NO;
          if(have_coretotie == DO) {
            err = InterpolateCoreTiePtValue(dset, ties->hole, ties->core, sm, ties->tiecorembsf, &tieptval, &dum);
            if(err > 0) {
              sx = xoff;
            }
            else {
              sx = (flip_core_adj * (tieptval - minvar) + flip_core_off)/perpix + xoff;
            }
          }
          else if(have_splice == DO) {
            err = InterpolateSpliceTiePtValue(sset, sm, ties->tiecoremcd, &tieptval, &dum);
            if(err > 0) {
              sx = xoff;
            }
            else {
              sx = (flip_core_adj * (tieptval - splice[sset]->min) + flip_core_off)/perpix + xoff;
            }
          }
        }
      } 
      if(have_affine == DO) {
        sy=(ties->tiecoremcd - top_meter)/depperpix + top_off;
      }
      else {
        sy=(ties->tiecorembsf - top_meter)/depperpix + top_off;
      }
      pointsize = 5;
      XSetForeground(dpy, gc, fgPixel[CLINE_TIEPT1]);
      XFillArc(dpy, xid, gc,
                       sx-(pointsize/2), sy-(pointsize/2),
                       pointsize, pointsize, 0, 360*64);

      xoff = logaxislen;
      sdx = sx + logaxislen;
      sdy = (ties->tiecoretempeqlogdep - top_meter)/depperpix + top_off;
      pointsize = 5;
      XSetForeground(dpy, gc, fgPixel[CLINE_TIEPT1]);
      XFillArc(dpy, xid, gc,
                       sdx-(pointsize/2), sdy-(pointsize/2),
                       pointsize, pointsize, 0, 360*64);
    }

    if(have_tie2 == DO) {
      xoff = 2 * logaxislen;
      if(ties->logtie >= 0 && ties->logtie < logdata[lset]->data_num) {
        if(logdata[lset]->info.smooth.method == GAUSSIAN && logdata[lset]->info.smooth.plot == SMOOTH || 
           logdata[lset]->info.smooth.plot == SMOOTHBOTH) {
          sdxl=(flip_log_adj * (logdata[lset]->value[ties->logtie]->sm_data - minlog) + flip_log_off)/logvarperpix + xoff;
        }
        else {
          sdxl = (flip_log_adj * (logdata[lset]->value[ties->logtie]->data - minlog) + flip_log_off)/logvarperpix + xoff;
        }
        sdyl = (logdata[lset]->value[ties->logtie]->depth - top_meter)/depperpix + top_off;
      }
      else if(ties->logtie == INTERP) {
        if(logdata[lset]->info.smooth.method != NONE) {
          sdxl=(flip_log_adj * (ties->tielogsmval - minlog) + flip_log_off)/logvarperpix + xoff; 
        }
        else {
          sdxl=(flip_log_adj * (ties->tielogval - minlog) + flip_log_off)/logvarperpix + xoff;
        }
        sdyl = (ties->tielogdep - top_meter)/depperpix + top_off;
      }
      else if(ties->logtie == MISSING) {
        sdxl = xoff;
        sdyl = (ties->tielogdep - top_meter)/depperpix + top_off;
      }
      pointsize = 5;
      XSetForeground(dpy, gc, fgPixel[CLINE_TIEPT2]);
      XFillArc(dpy, xid, gc,
                       sdxl-(pointsize/2), sdyl-(pointsize/2),
                       pointsize, pointsize, 0, 360*64);
    }

    /* tie line
    */
    if(have_tie1 == DO && have_tie2 == DO) {
      XSetForeground(dpy, gc, fgPixel[CLINE_TIELINELAST]);
/*      XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
*/
      XDrawLine(dpy, xid, gc, sdx, sdy, sdxl, sdyl);
    }

    /* if have ties in tie list
    */
    if(have_log == DO && ((have_coretotie == DO && ties->nties > 0) || (have_splice == DO && ties->nties > 1))) {

      hole = ties->hole; 
      core = ties->core;
      for(i=0; i<ties->nties; ++i) {

        if(i == 0 && have_splice == DO) {
        }
        else {

          if(ties->tie[i]->selected == NO) {
            XSetForeground(dpy, gc, fgPixel[CLINE_TIELINESADJUSTDONE]);
          }
          else if(ties->tie[i]->selected == YES) {
            XSetForeground(dpy, gc, fgPixel[CLINE_TIESELECT]);
          }

          xoff = 0;
          array = ties->tie[i]->array;
          log = ties->tie[i]->log;

          if(array < 0) {
            /* note that InterpolateCoreTiePtValue(0 does a linear interp to find the data value.
               hence it can use mbsf even if depths are plotted to eqlogdepth.
               also if in the future non-linear curve fits are used will need to write
               new code for finding tie pt value.
            */
            if(have_coretotie == DO) {
              err = InterpolateCoreTiePtValue(dset, ties->hole, ties->core, sm, ties->tie[i]->corembsf, &tieptval, &dum);
            }
            else if(have_splice == DO) {
              err = InterpolateSpliceTiePtValue(sset, sm, ties->tie[i]->coremcd, &tieptval, &dum);
            }
            if(err > 0) {
              sx = xoff;
            }
            else if(have_coretotie == DO) {
              sx = (flip_core_adj * (tieptval - minvar) + flip_core_off)/perpix + xoff;
            }
            else if(have_splice == DO) {
              sx = (flip_core_adj * (tieptval - splice[sset]->min) + flip_core_off)/perpix + xoff;
            }
          }
          else {
            if(sm == YES) {
              if(have_coretotie == DO) {
                sx = (flip_core_adj * (data[dset]->holes[hole]->core[core]->value[array]->sm_data - minvar) + flip_core_off)/perpix + xoff;
              }
              else if(have_splice == DO && sset >= 0 && sset < splice_cnt) {
                sx = (flip_core_adj * (splice[sset]->value[array]->sm_data - splice[sset]->min) + flip_core_off)/perpix + xoff;
              }
              else {
                sx = xoff;
              }
            }
            else {
              if(have_coretotie == DO) {
                sx = (flip_core_adj * (*data[dset]->holes[hole]->core[core]->value[array]->data - minvar) + flip_core_off)/perpix + xoff;
              }
              else if(have_splice == DO && sset >= 0 && sset < splice_cnt) {
                sx = (flip_core_adj * (splice[sset]->value[array]->data - splice[sset]->min) + flip_core_off)/perpix + xoff;
              }
              else {
                sx = xoff;
              }
            }
          }
          if(have_affine == DO) {
            sy=(ties->tie[i]->coremcd - top_meter)/depperpix + top_off;
          }
          else {
            sy=(ties->tie[i]->corembsf - top_meter)/depperpix + top_off;
          }
          xoff = logaxislen;
          sdx = sx + logaxislen;
          sdy = (ties->tie[i]->temp_eld - top_meter)/depperpix + top_off;
 /*         XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
*/

          xoff = 2 * logaxislen;
          if(logdata[lset]->info.smooth.method != NONE) {
            smlog = YES;
          }
          else {
            smlog = NO;
          }
          if(log < 0) {
            err = InterpolateLogTiePtValue(lset, smlog, ties->tie[i]->logdep, &tieptval, &dum);
            if(err > 0) {
              sdxl = xoff;
            }
            else {
              sdxl=(flip_log_adj * (tieptval - minlog) + flip_log_off)/logvarperpix + xoff;
            }
            sdyl =(ties->tie[i]->logdep - top_meter)/depperpix + top_off;
          }
          else {
            if(smlog != NO) {
              sdxl=(flip_log_adj * (logdata[lset]->value[log]->sm_data - minlog) + flip_log_off)/logvarperpix + xoff;
            }
            else {
              sdxl = (flip_log_adj * (logdata[lset]->value[log]->data - minlog) + flip_log_off)/logvarperpix + xoff;
            }
            sdyl =(logdata[lset]->value[log]->depth - top_meter)/depperpix + top_off;
          }
          XDrawLine(dpy, xid, gc, sdx, sdy, sdxl, sdyl);
        }
      }
    }
    else if(have_splice == DO && ties->nties > 1) {
      xoff = logaxislen;
      for(i=1; i<ties->nties; ++i) {
        array = ties->tie[i]->array;
        if(array < 0 || array >= splice[sset]->numvalues) {
          InterpolateSpliceTiePtValue(sset, sm, ties->tie[i]->coremcd, &tieptval, &dum);
        }
        else {
          tieptval = splice[sset]->value[array]->mcd;
        }
        sx = (flip_core_adj * (tieptval - splice[sset]->min) + flip_core_off)/varperpix+xoff;
        sy = (ties->tie[i]->equivlogdep - top_meter)/depperpix+top_off;
        XDrawLine(dpy, xid, gc, sx - 5, sy, sx + 5, sy);
      }
    }
  }

  if((have_ancill == DO && scale_val == 1) || (have_ancill == DO && have_log == DONT && scale_val == 0)) {
    if(scale_val == 1) {
      xoff = logaxislen + SPACE;
    }
    else if(scale_val == 0) {
      xoff = 0;
    }
    for(i=0; i<ancill.data_cnt; ++i) {
      perpix = (ancill.axis_max[i] - ancill.axis_min[i])/ancill.axislen;
      if(i == 0) {
        XSetForeground(dpy, gc, fgPixel[CLINE_ANCILLARY1]);
      }
      else if(i == 1) {
        XSetForeground(dpy, gc, fgPixel[CLINE_ANCILLARY2]);
      }
      else if(i == 2) {
        XSetForeground(dpy, gc, fgPixel[CLINE_ANCILLARY3]);
      }
      else {
        XSetForeground(dpy, gc, fgPixel[CLINE_ANCILLARY1]);
      }
      k = 0;
      while(ancill.value[k]->data[i] == ancill.missing_value && k < ancill.data_num) {
        ++k;
      }
      sx = (ancill.value[k]->data[i] - ancill.axis_min[i])/perpix + xoff;
      sy = (ancill.value[k]->depth + autooff - top_meter)/depperpix + top_off;
      for(j=k+1; j<ancill.data_num; ++j) {
        if(ancill.value[j-1]->data[i] == ancill.missing_value ||
          ancill.value[j]->data[i] == ancill.missing_value) {
        }
        else {
          sdx = (ancill.value[j]->data[i] - ancill.axis_min[i])/perpix + xoff;
          sdy = (ancill.value[j]->depth + autooff - top_meter)/depperpix + top_off;
          if(sdy < top_off) {
          }
          else if(sy > (int)win_height) {
            break;
          }
          else {
            XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
          }
          sx = sdx;
          sy = sdy;
        }
      }
    }
  }


/* test 
  if(have_splice == DO) {
    xoff = SPACE + VARLEN;
    XSetForeground(dpy, gc, fgPixel[CLINE_COREOVERLAYOUTCORR]);
    if((sbd=(float*)calloc(splice[sset]->numvalues,sizeof(float))) == NULL)
                                   SaBadMemAlloc("Sa");
    if((dat=(float*)calloc(splice[sset]->numvalues,sizeof(float))) == NULL)
                                    SaBadMemAlloc("Sa");
    for(j=0; j<splice[sset]->numvalues-1; ++j) {
      dat[j] = splice[sset]->value[j]->data - splice[sset]->value[j+1]->data; 
    }
    sx = (flip_core_adj * (splice[sset]->value[start]->data - splice[sset]->min) + flip_core_off)/perpix + xoff;
    sy = ((splice[sset]->value[start]->mcd * squish) - top_meter)/depperpix + top_off;
    for(j=0; j<n; ++j) {
      sdx = (flip_core_adj * (splice[sset]->value[j]->data - splice[sset]->min) + flip_core_off)/perpix + xoff;
      sdy = ((splice[sset]->value[j]->mcd * squish) - top_meter)/depperpix + top_off;
      if(sdy < top_off) {
      }
      else if(sy > (int)win_height) {
        break;
      }
      else {
        XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
      }
      sx = sdx;
      sy = sdy;
    }
  }
*/

}

void DrawAdjustToTiesInfo(w, dpy, xid, gc, clip)
Widget w;
Display *dpy;
Window xid;
GC gc;
int clip;
{
  int i, n, naxes, left, ticpixlen, annot, label, pixwidth, pixheight, axiswidth, pixpervar, 
      trunc, eq1, eq2, sx, sy, sdx, sdy, xoff;
  char s[50];
  float unitinc, min, max, minmeter, scalepix, depscalepix, depinc, maxmeter, var, minmeterlog, maxmeterlog, tickcheck, affoff;
  double check, fract, ip;
  Dimension win_height, win_width;

  XClearWindow(dpy, xid);
  XtVaGetValues(w, XmNheight, &win_height, XmNwidth, &win_width, NULL);

  if(have_coretotie == DO) {
    n = data[dset]->holes[ties->hole]->core[ties->core]->numvalues;
    if(have_affine == DO) {
      affoff = data[dset]->holes[ties->hole]->core[ties->core]->affine_offset;
    }
    else {
      affoff = 0.0;
    }

    trunc = data[dset]->holes[ties->hole]->core[ties->core]->value[n-1]->mbsf + affoff;
    maxmeter = trunc + 1;
    trunc = data[dset]->holes[ties->hole]->core[ties->core]->value[0]->mbsf + affoff;
    minmeter = trunc;
    trunc = ties->temp_equivlogdep[0];
    minmeterlog = trunc;
    trunc = ties->temp_equivlogdep[n-1];
    maxmeterlog = trunc + 1;
    if(minmeter > minmeterlog) {
      minmeter = minmeterlog;
    }
    if(maxmeter < maxmeterlog) {
      maxmeter = maxmeterlog;
    }
    depinc = 2.0;
    check = (maxmeter - minmeter)/deptic;
    fract = modf(check, &ip);
    if(fract == 0.0){
    }
    else {
      maxmeter = minmeter + (ip * depinc) + depinc;
    }
    left = 0;
    depscalepix = ((int)win_height - OFF - SPACE)/(maxmeter - minmeter);
    ticpixlen = depinc * depscalepix;
    annot = YES;
    label = NO;

    /* set color for axis and labels
    */
    XSetForeground(dpy, gc, fgPixel[CLINE_LABEL]);
    AxisDep(w, dpy, xid, gc,
          maxmeter, OFF, left, ticpixlen, depinc, minmeter, depscalepix, annot, label);
    if(have_affine == DO) {
      (void)sprintf(s,"mcd");
    }
    else {
      (void)sprintf(s,"mbsf");
    }
    XDrawString(dpy, xid, gc, 8, OFF + 60, s, (int)strlen(s));

    pixwidth = (int)win_width - OFF - SPACE;
    pixheight = (int)win_height - OFF - SPACE;
    axiswidth = (pixwidth - pixheight - 3 * SPACE)/2.0;
    if(axiswidth < 5) { 
      return;
    } 

    XDrawLine(dpy, xid, gc, OFF+SPACE, OFF, OFF+SPACE + pixheight, OFF);
    XDrawLine(dpy, xid, gc, OFF+SPACE + pixheight + SPACE, OFF, OFF+SPACE + pixheight + SPACE + axiswidth, OFF);
    XDrawLine(dpy, xid, gc,
              OFF+SPACE + pixheight + 2 * SPACE + axiswidth, OFF, OFF+SPACE + pixheight + 2 * SPACE + 2 * axiswidth, OFF);

    (void)sprintf(s,"%.0f", minmeter);
    XDrawString(dpy, xid, gc, OFF + SPACE - 3, OFF - 10, s, (int)strlen(s));
    (void)sprintf(s,"%.0f", maxmeter);
    XDrawString(dpy, xid, gc, OFF + SPACE + pixheight - 8, OFF - 10, s, (int)strlen(s));
    (void)sprintf(s,"Equivalent Log Depth");
    XDrawString(dpy, xid, gc, OFF + SPACE + pixheight/2 - 50, OFF - 25, s, (int)strlen(s));

    tickcheck = minmeter;
    sx = OFF + SPACE;
    while(tickcheck <= maxmeter) {
      XDrawLine(dpy, xid, gc, sx, OFF, sx, OFF-5);
      tickcheck = tickcheck + depinc;
      sx = sx + ticpixlen;
    }

    /* draw original ODP depth versus equivelent log depth
    */     
    XSetForeground(XtDisplay(w), gc_drawingAreaAdjustToTiesInfo, fgPixel[CLINE_ADJUSTTOTIESSTATS]);
    for(i=0; i<n-1; ++i) {
      sx = (ties->temp_equivlogdep[i] - minmeter) * depscalepix + OFF + SPACE;
      sy = (data[dset]->holes[ties->hole]->core[ties->core]->value[i]->mbsf + affoff - minmeter) * depscalepix + OFF;
      sdx = (ties->temp_equivlogdep[i+1] - minmeter) * depscalepix + OFF + SPACE;
      sdy = (data[dset]->holes[ties->hole]->core[ties->core]->value[i+1]->mbsf + affoff - minmeter) * depscalepix + OFF;
      XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
    }

    /* draw a line from core's original min to max
    
    XSetForeground(dpy, gc, fgPixel[CLINE_FORAM]);
    sx = (data[dset]->holes[ties->hole]->core[ties->core]->value[0]->mbsf - minmeter) * depscalepix + OFF + SPACE;
    sy = (data[dset]->holes[ties->hole]->core[ties->core]->value[0]->mbsf - minmeter) * depscalepix + OFF;
    sdx = (data[dset]->holes[ties->hole]->core[ties->core]->value[n-1]->mbsf - minmeter) * depscalepix + OFF + SPACE;
    sdy = (data[dset]->holes[ties->hole]->core[ties->core]->value[n-1]->mbsf - minmeter) * depscalepix + OFF;
    XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
*/
    /* draw line where ties are relative to depth of y axis (orig ODP depth)
    */   
    if(ties->nties > 0) {
      XSetForeground(dpy, gc, fgPixel[CLINE_CORRELATIONBEST]);
      for(i=0; i<ties->nties; ++i) {
        sx = OFF+SPACE + pixheight - 5;
        sdx = OFF+SPACE + pixheight + 5;
        sy = (ties->tie[i]->corembsf + affoff - minmeter) * depscalepix + OFF; 
        XDrawLine(dpy, xid, gc, sx, sy, sdx, sy);
      }
    }

    XSetForeground(dpy, gc, fgPixel[CLINE_ADJUSTTOTIESSTATS]);

 /* draw the amount of squish and stretch
  
    pixpervar = axiswidth/2.0;
    if(ties->nties > 1) {
      for(i=0; i<ties->nties-1; ++i) {
        eq1 = ties->tie[i]->array;
        eq2 = ties->tie[i+1]->array;
        if(eq1 < 0 || eq2 < 0) {
        }
        else {
          var = (ties->temp_equivlogdep[eq2] - ties->temp_equivlogdep[eq1])/
                (ties->tie[i+1]->corembsf - ties->tie[i]->corembsf) - 1.0;
          sx = var * pixpervar + OFF + pixpervar;
          sy = (ties->tie[i]->corembsf - minmeter) * depscalepix + OFF;
          sdy = (ties->tie[i+1]->corembsf - minmeter) * depscalepix + OFF;
          XDrawLine(dpy, xid, gc, sx, sy, sx, sdy);
          if(i > 0) {
            eq1 = ties->tie[i-1]->array;
            eq2 = ties->tie[i]->array;
            var = (ties->temp_equivlogdep[eq2] - ties->temp_equivlogdep[eq1])/
                  (ties->tie[i]->corembsf - ties->tie[i-1]->corembsf) - 1.0;
            sdx = var * pixpervar + OFF + pixpervar;
            XDrawLine(dpy, xid, gc, sx, sy, sdx, sy);
          }
        }
      }
    }
*/

    /* draw actual change in depth 
    */

    /* draw relative change in depth; -loss: +gain; (eqyivlog - origdep) - first dep shift.
    
    XSetForeground(dpy, gc, fgPixel[CLINE_LABEL]);
    xoff = OFF + SPACE + pixheight + SPACE;
    min = 9999.0;
    max = -9999.0;
    for(i=0; i<n; ++i) {
      if(ties->temp_equivlogdep[i] - data[dset]->holes[ties->hole]->core[ties->core]->value[i]->mbsf > max) {
        max = ties->temp_equivlogdep[i] - data[dset]->holes[ties->hole]->core[ties->core]->value[i]->mbsf; 
      }
      if(ties->temp_equivlogdep[i] - data[dset]->holes[ties->hole]->core[ties->core]->value[i]->mbsf < min) {
        min = ties->temp_equivlogdep[i] - data[dset]->holes[ties->hole]->core[ties->core]->value[i]->mbsf;
      }
    }
    (void)strcpy(s, "");
    if(abs(max-min) > 0) {
      scalepix = axiswidth/fabs(max-min);
      (void)sprintf(s,"%.2f", min);
      XDrawString(dpy, xid, gc, xoff, OFF - 10, s, (int)strlen(s));
      (void)sprintf(s,"%.2f", max);
      XDrawString(dpy, xid, gc, xoff + axiswidth, OFF - 10, s, (int)strlen(s)); 
      XDrawLine(dpy, xid, gc, xoff, OFF, xoff, OFF-5);
      XDrawLine(dpy, xid, gc, xoff + axiswidth, OFF, xoff + axiswidth, OFF-5);
    }
    else {
      scalepix = 0.0;
      (void)sprintf(s,"%.2f", min);
      XDrawString(dpy, xid, gc, xoff, OFF - 10, s, (int)strlen(s));
      XDrawLine(dpy, xid, gc, xoff, OFF, xoff, OFF-5); 
    }
*/
/*
    XSetForeground(dpy, gc, fgPixel[CLINE_ADJUSTTOTIESSTATS]);
    for(i=0; i<n-1; ++i) {
      sx = (ties->temp_equivlogdep[i] - data[dset]->holes[ties->hole]->core[ties->core]->value[i]->mbsf - 
            - min) * scalepix + xoff + SPACE; 
      sy = (data[dset]->holes[ties->hole]->core[ties->core]->value[i]->mbsf - minmeter) * depscalepix + OFF;
      sdx = (ties->temp_equivlogdep[i+1] - data[dset]->holes[ties->hole]->core[ties->core]->value[i+1]->mbsf - 
             - min) * scalepix + xoff + SPACE; 
      sdy = (data[dset]->holes[ties->hole]->core[ties->core]->value[i+1]->mbsf - minmeter) * depscalepix + OFF;
      XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
    }
*/
    /* draw corr. coef at each tie
    */
  }
  else {
  }
}

void DrawCorrelate(w, dpy, xid, gc, clip)
Widget w;
Display *dpy;
Window xid;
GC gc;
int clip;
{
  int i, lag, lagtic, nlagtic, maxlag, sx, sy, sdx, sdy,
      xaxispixlen, yaxispixlen;
  float  leadlagmeters;
  double fract, check, ip;
  Dimension win_height, win_width;
  XGCValues gcValues;
  String    str;

  XClearWindow(dpy, xid);
  if(have_tie1 != DO || have_tie2 != DO) {
    return;
  }

  XtVaGetValues(w, XmNheight, &win_height, XmNwidth, &win_width, NULL);

  /*calc. the length of the y axis and the half length
    of the x axis. 
  */
  xaxispixlen = ((int)win_width - (2 * SPACE))/2;
  yaxispixlen = ((int)win_height - (2 * SPACE));

  /* get the lead/lag
  */
  str = XmTextGetString(textFieldLeadLag);
  leadlagmeters = atof(str);
  XtFree(str);

  check = yaxispixlen;
  corrperpix = 2.0/check;
  lagperpix = leadlagmeters/xaxispixlen;
  nlagtic = 1;
  lagtic = 1;

 
  /* set axis and label color
  */
  XSetForeground(dpy, gc, fgPixel[CLINE_LABEL]);
  
  AxesCorrelate(w, dpy, xid, gc, lagtic, nlagtic, leadlagmeters, yaxispixlen, xaxispixlen);
 
  /* set corr. coef. color and draw it
  */   
  XSetForeground(dpy, gc, fgPixel[CLINE_CORRELATION]);
 
  for(i=0; i<corr.num_lead_lag-1; ++i){
    sx = (corr.leadlag_in_meter[i]/lagperpix) + SPACE + xaxispixlen;
    sy = -1.0 * (corr.coef[i]/corrperpix) + SPACE + yaxispixlen/2;
    sdx = (corr.leadlag_in_meter[i+1]/lagperpix) + SPACE + xaxispixlen;
    sdy = -1.0 * (corr.coef[i+1]/corrperpix) + SPACE + yaxispixlen/2;
    XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
  }

  XSetForeground(dpy, gc, fgPixel[CLINE_CORRELATIONBEST]);
  gcValues.line_width = 2;
/*  XChangeGC(dpy, gc, GCLineWidth, &gcValues);
*/
  sx =  (corr.leadlag_in_meter[best_corr_num]/lagperpix) + SPACE + xaxispixlen;
  XDrawLine(dpy, xid, gc, sx, (SPACE + yaxispixlen/2) - 5, sx, (SPACE + yaxispixlen/2) + 5);
  gcValues.line_width = 0;
/*  XChangeGC(dpy, gc, GCLineWidth, &gcValues);
*/
}

void FindNearestSample(ds, first_hole, pholenum, pcorenum, parraynum, x, y, sm, depth, axislen)
int ds, *pholenum, *pcorenum, *parraynum, x, y, sm, first_hole, axislen;
float depth;
{
  int i, j, k;
  float chlow, chhigh, diff, diffcheck;
  double checkdep;

  /* find the nearest sample to pixel location
  */
  *pholenum = -1;
  *pcorenum = -1;
  *parraynum = -1;
  /* find which hole
  */
  if(first_hole >= data[ds]->numholes) {
    return;
  }
  for(i=first_hole; i<data[ds]->numholes; ++i){
    if(x >= OFF + SPACE + (i - first_hole) * (axislen + SPACE) &&
       x <= OFF + SPACE + (i - first_hole) * (axislen + SPACE) + axislen &&
       y >= top_off) {
       *pholenum = i;
       break;
    }
  }
         
  /* find which core
  */
  if(*pholenum != -1) {
    for(j=0; j < data[ds]->holes[*pholenum]->numcores; ++j){
      if(data[ds]->holes[*pholenum]->core[j]->value[0]->quality == BAD_CORE_NUM){
      } 
      else {
        for(k=0; (data[ds]->holes[*pholenum]->core[j]->value[k]->quality & ~BAD_SMOOTH) != GOOD; ++k){
          if(k >= data[ds]->holes[*pholenum]->core[j]->numvalues){
            break;
          }
        }
        if(data[ds]->holes[*pholenum]->core[j]->have_equil_log_depths == DO) {
          chlow = data[ds]->holes[*pholenum]->core[j]->value[k]->eld;
        }
        else {
          chlow=data[ds]->holes[*pholenum]->core[j]->value[k]->mbsf + data[ds]->holes[*pholenum]->core[j]->affine_offset;
        }
        for(k=data[ds]->holes[*pholenum]->core[j]->numvalues -1;
            (data[ds]->holes[*pholenum]->core[j]->value[k]->quality & ~BAD_SMOOTH) != GOOD; --k){
          if(k <= 0){
            break;
          }
        }
        if(data[ds]->holes[*pholenum]->core[j]->have_equil_log_depths == DO) {
          chhigh = data[ds]->holes[*pholenum]->core[j]->value[k]->eld;
        }
        else {
          chhigh= data[ds]->holes[*pholenum]->core[j]->value[k]->mbsf + data[ds]->holes[*pholenum]->core[j]->affine_offset;
        }
        if(depth >= chlow && depth <= chhigh){
          *pcorenum=j;
          break;
        }
      }
    }
  } 

  /* find nearest good sample
  */
  if(*pcorenum != -1 && *pholenum != -1) {
    diff = 99999.0;
    diffcheck = diff;
    for(k=0; k<data[ds]->holes[*pholenum]->core[*pcorenum]->numvalues; ++k){
      if(data[ds]->holes[*pholenum]->core[j]->have_equil_log_depths == DO) {
        checkdep = depth - data[ds]->holes[*pholenum]->core[*pcorenum]->value[k]->eld;
      }
      else {
        checkdep = depth - (data[ds]->holes[*pholenum]->core[*pcorenum]->value[k]->mbsf + 
                   data[ds]->holes[*pholenum]->core[j]->affine_offset);
      }
      if(sm == NO && (data[ds]->holes[*pholenum]->core[*pcorenum]->value[k]->quality & ~BAD_SMOOTH) != GOOD) {
      }
      else if(sm == YES && data[ds]->holes[*pholenum]->core[*pcorenum]->value[k]->quality != GOOD){
      }
      else if(fabs(checkdep) < diff){
        diff = fabs(checkdep);
        *parraynum = k;
      }
    }
  } 
}

/* clean up one cores depth and var
   for either plotting or correlation.
   find and average mult samples per level,
   remove bad values,
   chack that samples in desending order,
   (future) deal with gaps in data.
*/
int CleanUpCore(ds, hnum, cnum, psbd, pdata, sm, ptie, eq)
int ds, hnum, cnum, sm, *ptie, eq;
float *pdata, *psbd;
{
  int j, k, nbad, ndiv;
  float sum;

  /*look for and trash any bad data by not storing
    them in the pointers pdata and psbd
  */

  nbad = 0;
  for(j=0; j<data[ds]->holes[hnum]->core[cnum]->numvalues; ++j) {
    if(sm == NO && (data[ds]->holes[hnum]->core[cnum]->value[j]->quality & ~BAD_SMOOTH) == GOOD){
      pdata[j] = *data[ds]->holes[hnum]->core[cnum]->value[j]->data;
      if(eq == DO || eq == ELD) {
        psbd[j] = data[ds]->holes[hnum]->core[cnum]->value[j]->eld;
      }
      else if(eq == TEMP) {
        psbd[j] = ties->temp_equivlogdep[j];
      }
      else if(eq == AUTO) {
        psbd[j] = ties->coredepth[j];
      }
      else if(eq == DONT) {
        psbd[j] = data[ds]->holes[hnum]->core[cnum]->value[j]->mbsf;
        if(have_affine == DO) {
          psbd[j] = psbd[j] + data[dset]->holes[hnum]->core[cnum]->affine_offset;
        }
      }
    }
    else if(sm == YES && data[ds]->holes[hnum]->core[cnum]->value[j]->quality == GOOD){
      pdata[j] = data[ds]->holes[hnum]->core[cnum]->value[j]->sm_data;
      if(eq == DO || eq == ELD) { 
        psbd[j] = data[ds]->holes[hnum]->core[cnum]->value[j]->eld;
      }
      else if(eq == TEMP) { 
        psbd[j] = ties->temp_equivlogdep[j]; 
      } 
      else if(eq == AUTO) {
        psbd[j] = ties->coredepth[j];
      }
      else if(eq == DONT) { 
        psbd[j] = data[ds]->holes[hnum]->core[cnum]->value[j]->mbsf; 
        if(have_affine == DO) {
          psbd[j] = psbd[j] + data[dset]->holes[hnum]->core[cnum]->affine_offset;
        }
      }
    }
    else {
      pdata[j] = BADPT;
      psbd[j] = BADPT;
      ++nbad;
    }
  }
 
  /* check that there are at least two good data points in
     this core
  */
  if(data[ds]->holes[hnum]->core[cnum]->numvalues - nbad < 2) {
    return 1;
  }

  return 0;
}

void ReadColorList(dpy)
Display *dpy;
{
  int start, i, err;
  char line[1000], rgbcolor[51], *color_path, *filename, *getenv();
  FILE *fp;
  XmString xmstring;
  Pixel sampPixel;
  int GetColorPixelValue();

  start = 0;
  sprintf(line,"");

  if((color_path=(char*)calloc(1000, CHAR_SIZE))==NULL)
                 SaBadMemAlloc("ReadColorList");
  (void)strcpy(color_path,(char*)getenv("SAGAN_COLOR_PATH"));
  if((filename=(char*)calloc((int)strlen(color_path) + 50, CHAR_SIZE))==NULL)
                 SaBadMemAlloc("ReadColorList");
  (void)sprintf(filename, "%s/color-name-list", color_path);
  free(color_path);

  if((fp = fopen(filename, "r")) != NULL) {
    while(fgets(line, 1000, fp) != NULL) {

      sscanf(line,"%*d %*d %*d %s", &rgbcolor);

      xmstring = XmStringCreateSimple(rgbcolor);
      XmListAddItemUnselected(listColor, xmstring, 0);
      XmStringFree(xmstring);

      if(start == 0) {
       
        /* let the first color in the list be the selected
           and displayed sample color
        */
        err = GetColorPixelValue(dpy, cmap, rgbcolor, &sampPixel);
        XtVaSetValues(drawingAreaColorListSelect, XmNbackground, sampPixel, NULL);
        XmListSelectPos(listColor, 1, NULL);
        start = 1;
      }
      strcpy(line, "");
    }
    fclose(fp);
  }
  else {
    (void)sprintf(buffer,"Error; Could not open sagans color name list.");
    SaManageWarningBox(buffer);
  }
  free(filename);
}

int GetColorPixelValue(dpy, colormap, rgbc, pixel)
Display *dpy;
Colormap  *colormap;
char *rgbc;
Pixel *pixel;
{
  XColor return_color, unused;
  XColor test_color;
  int err;

  if(rgbc) {
    if(!XAllocNamedColor(dpy, colormap, rgbc, &return_color, &unused)) {
      (void)printf("can not allocate named color.  %s", rgbc);
      *pixel = BlackPixelOfScreen(XtScreen(drawingAreaColorListSelect));
      return True;
    }
    else {
      *pixel = return_color.pixel;
      return False;
    }
  }
  else {
    (void)sprintf(buffer,"Error; Can not allocate color. Its variable name is = nil..");
    SaManageWarningBox(buffer);
    *pixel = BlackPixelOfScreen(XtScreen(drawingAreaColorListSelect));
    return True;
  }
}

void CustomColorBackgroundChange(pixel)
Pixel pixel;
{

  XtVaSetValues(rowColumnCoreColors, XmNbackground, pixel, NULL);
  XtVaSetValues(rowColumnLogColors, XmNbackground, pixel, NULL);
  XtVaSetValues(rowColumnTieColors, XmNbackground, pixel, NULL);
  XtVaSetValues(rowColumnStratColor, XmNbackground, pixel, NULL);
  XtVaSetValues(rowColumnAncillaryLogColors, XmNbackground, pixel, NULL);
  XtVaSetValues(rowColumnCorrelationColors, XmNbackground, pixel, NULL);
  XtVaSetValues(rowColumnCoreAdjustStatsColors, XmNbackground, pixel, NULL);
  XtVaSetValues(rowColumnDrawBackgroundColor, XmNbackground, pixel, NULL);

  XtVaSetValues(labelColorCore, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorCoremcd, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorCoreSmooth, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorCoreEquivLogDepth, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorLogLog, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorLogAdjust, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorLogSmooth, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorLogCoreOverlayInCorr, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorLogCoreOverlayOutCorr, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorStratPaleomag, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorStratDiatom, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorStratRad, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorStratForam, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorStratNanno, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorTiePtCore, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorTiePtLog, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorTieNew, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorTieAdjusted, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorTieSelected, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorAncillaryLog1, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorAncillaryLog2, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorAncillaryLog3, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorCorrelationCorrCoef, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorCorrelationBest, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorCoreAdjustStatsStats, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorLabels, XmNbackground, pixel, NULL);
  XtVaSetValues(labelColorBackground, XmNbackground, pixel, NULL);

  XtVaSetValues(pushButtonColorBackground, XmNbackground, pixel, NULL);
}

void CustomColorLabelChange(pixel)
Pixel pixel;
{
  XtVaSetValues(labelColorCore, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorCoremcd, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorCoreSmooth, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorCoreEquivLogDepth, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorLogLog, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorLogAdjust, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorLogSmooth, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorLogCoreOverlayInCorr, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorLogCoreOverlayOutCorr, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorStratPaleomag, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorStratDiatom, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorStratRad, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorStratForam, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorStratNanno, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorTiePtCore, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorTiePtLog, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorTieNew, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorTieAdjusted, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorTieSelected, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorAncillaryLog1, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorAncillaryLog2, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorAncillaryLog3, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorCorrelationCorrCoef, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorCorrelationBest, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorCoreAdjustStatsStats, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorLabels, XmNforeground, pixel, NULL);
  XtVaSetValues(labelColorBackground, XmNforeground, pixel, NULL);
}

void SetCustomeColorButtonColors(bgP, buttP, buttColorName)
Pixel bgP, buttP[NCUSTOMECOLORBUTT];
char buttColorName[NCUSTOMECOLORBUTT][50];
{
  XmString xmstring;

  XtVaSetValues(pushButtonColorBackground, XmNbackground, bgP, NULL);
  xmstring = XmStringCreateSimple(buttColorName[BG_COLOR]);
  XtVaSetValues(pushButtonColorBackground, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorLabels, XmNbackground, buttP[CLINE_LABEL], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_LABEL]);
  XtVaSetValues(pushButtonColorLabels, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorAncillaryLog1, XmNbackground, buttP[CLINE_ANCILLARY1], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_ANCILLARY1]);
  XtVaSetValues(pushButtonColorAncillaryLog1, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorAncillaryLog2, XmNbackground, buttP[CLINE_ANCILLARY2], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_ANCILLARY2]);
  XtVaSetValues(pushButtonColorAncillaryLog2, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorAncillaryLog3, XmNbackground, buttP[CLINE_ANCILLARY3], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_ANCILLARY3]);
  XtVaSetValues(pushButtonColorAncillaryLog3, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorCoreAdjustStatsStats, XmNbackground, buttP[CLINE_ADJUSTTOTIESSTATS], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_ADJUSTTOTIESSTATS]);
  XtVaSetValues(pushButtonColorCoreAdjustStatsStats, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorCorrelationCorrCoef, XmNbackground, buttP[CLINE_CORRELATION], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_CORRELATION]);
  XtVaSetValues(pushButtonColorCorrelationCorrCoef, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorCorrelationBest, XmNbackground, buttP[CLINE_CORRELATIONBEST], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_CORRELATIONBEST]);
  XtVaSetValues(pushButtonColorCorrelationBest, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorStratPaleomag, XmNbackground, buttP[CLINE_PALEOMAG], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_PALEOMAG]);
  XtVaSetValues(pushButtonColorStratPaleomag, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorStratDiatom, XmNbackground, buttP[CLINE_DIATOM], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_DIATOM]);
  XtVaSetValues(pushButtonColorStratDiatom, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorStratRad, XmNbackground, buttP[CLINE_RAD], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_RAD]);
  XtVaSetValues(pushButtonColorStratRad, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorStratForam, XmNbackground, buttP[CLINE_FORAM], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_FORAM]);
  XtVaSetValues(pushButtonColorStratForam, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorStratNanno, XmNbackground, buttP[CLINE_NANNO], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_NANNO]);
  XtVaSetValues(pushButtonColorStratNanno, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorTiePtCore, XmNbackground, buttP[CLINE_TIEPT1], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_TIEPT1]);
  XtVaSetValues(pushButtonColorTiePtCore, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorTiePtLog, XmNbackground, buttP[CLINE_TIEPT2], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_TIEPT2]);
  XtVaSetValues(pushButtonColorTiePtLog, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorTieNew, XmNbackground, buttP[CLINE_TIELINELAST], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_TIELINELAST]);
  XtVaSetValues(pushButtonColorTieNew, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorTieAdjusted, XmNbackground, buttP[CLINE_TIELINESADJUSTDONE], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_TIELINESADJUSTDONE]);
  XtVaSetValues(pushButtonColorTieAdjusted, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorTieSelected, XmNbackground, buttP[CLINE_TIESELECT], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_TIESELECT]);
  XtVaSetValues(pushButtonColorTieSelected, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorLogLog, XmNbackground, buttP[CLINE_LOG], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_LOG]);
  XtVaSetValues(pushButtonColorLogLog, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorLogAdjust, XmNbackground, buttP[CLINE_LOGADJDEPTH], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_LOGADJDEPTH]);
  XtVaSetValues(pushButtonColorLogAdjust, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorLogSmooth, XmNbackground, buttP[CLINE_LOGSMOOTH], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_LOGSMOOTH]);
  XtVaSetValues(pushButtonColorLogSmooth, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorLogCoreOverlayInCorr, XmNbackground, buttP[CLINE_COREOVERLAYINCORR], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_COREOVERLAYINCORR]);
  XtVaSetValues(pushButtonColorLogCoreOverlayInCorr, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorLogCoreOverlayOutCorr, XmNbackground, buttP[CLINE_COREOVERLAYOUTCORR], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_COREOVERLAYOUTCORR]);
  XtVaSetValues(pushButtonColorLogCoreOverlayOutCorr, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorCore, XmNbackground, buttP[CLINE_COREODPSBD], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_COREODPSBD]);
  XtVaSetValues(pushButtonColorCore, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorCoremcd, XmNbackground, buttP[CLINE_COREMCD], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_COREMCD]);
  XtVaSetValues(pushButtonColorCoremcd, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorCoreSmooth, XmNbackground, buttP[CLINE_CORESMOOTH], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_CORESMOOTH]);
  XtVaSetValues(pushButtonColorCoreSmooth, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);

  XtVaSetValues(pushButtonColorCoreEquivLogDepth, XmNbackground, buttP[CLINE_COREEQUIVLOGDEPTH], NULL);
  xmstring = XmStringCreateSimple(buttColorName[CLINE_COREEQUIVLOGDEPTH]);
  XtVaSetValues(pushButtonColorCoreEquivLogDepth, XmNlabelString, xmstring, NULL);
  XmStringFree(xmstring);
}

void SetColorSetBGandFG()
{
Pixel fgP, bgP;

  /* get the custom color dialog's foreground and background colors
  */
  XtVaGetValues(formCustomizeColor, XmNbackground, &bgP, NULL);
  XtVaGetValues(formCustomizeColor, XmNforeground, &fgP, NULL);

  /* set all the color set buttons to the parents background and
     foreground colors
  */
  XtVaSetValues(pushButtonColorSetEarth, XmNbackground, bgP, NULL);
  XtVaSetValues(pushButtonColorSetCorporate, XmNbackground, bgP, NULL);
  XtVaSetValues(pushButtonColorSetMaritime, XmNbackground, bgP, NULL);
  XtVaSetValues(pushButtonColorSetSantaFe, XmNbackground, bgP, NULL);
  XtVaSetValues(pushButtonColorSetODP, XmNbackground, bgP, NULL);
  XtVaSetValues(pushButtonColorSetCustom, XmNbackground, bgP, NULL);
  XtVaSetValues(pushButtonColorSetEarth, XmNforeground, fgP, NULL);
  XtVaSetValues(pushButtonColorSetCorporate, XmNforeground, fgP, NULL);
  XtVaSetValues(pushButtonColorSetMaritime, XmNforeground, fgP, NULL);
  XtVaSetValues(pushButtonColorSetSantaFe, XmNforeground, fgP, NULL);
  XtVaSetValues(pushButtonColorSetODP, XmNforeground, fgP, NULL);
  XtVaSetValues(pushButtonColorSetCustom, XmNforeground, fgP, NULL);

  /* now set the background color of button of current colorset using
     to the drawingarea background color abd the button label colors
     to the general label color
  */
  if(colorset == EARTH_COLORSET) {
    XtVaSetValues(pushButtonColorSetEarth, XmNbackground, bgPixel, NULL);
    XtVaSetValues(pushButtonColorSetEarth, XmNforeground, fgPixel[CLINE_LABEL], NULL);
  }
  else if(colorset == CORPORATE_COLORSET) {
    XtVaSetValues(pushButtonColorSetCorporate, XmNbackground, bgPixel, NULL);
    XtVaSetValues(pushButtonColorSetCorporate, XmNforeground, fgPixel[CLINE_LABEL], NULL);
  }
  else if(colorset == MARITIME_COLORSET) {
    XtVaSetValues(pushButtonColorSetMaritime, XmNbackground, bgPixel, NULL);
    XtVaSetValues(pushButtonColorSetMaritime, XmNforeground, fgPixel[CLINE_LABEL], NULL);
  }
  else if(colorset == SANTAFE_COLORSET) {
    XtVaSetValues(pushButtonColorSetSantaFe, XmNbackground, bgPixel, NULL);
    XtVaSetValues(pushButtonColorSetSantaFe, XmNforeground, fgPixel[CLINE_LABEL], NULL);
  }
  else if(colorset == ODP_COLORSET) {
    XtVaSetValues(pushButtonColorSetODP, XmNbackground, bgPixel, NULL);
    XtVaSetValues(pushButtonColorSetODP, XmNforeground, fgPixel[CLINE_LABEL], NULL);
  }
  else if(colorset == CUSTOME_COLORSET) {
    XtVaSetValues(pushButtonColorSetCustom, XmNbackground, bgPixel, NULL);
    XtVaSetValues(pushButtonColorSetCustom, XmNforeground, fgPixel[CLINE_LABEL], NULL);
  }
}

int MapEqLogDepthToData()
{

}

void GetColor(w, butt, who)
Widget w;
Widget butt;
int who;
{
  int item_count, err;
  char *rgbcolor;
  XmString *pcolor, xmstring;
  Pixel sampPixel;
  int GetColorPixelValue();
  void  CustomColorBackgroundChange(), CustomColorLabelChange();;

  /* get the selected color name from the list
  */
  XtVaGetValues(listColor, XmNselectedItemCount,&item_count,
                XmNselectedItems,&pcolor, NULL);
  XmStringGetLtoR(pcolor[0], XmFONTLIST_DEFAULT_TAG, &rgbcolor);

  /* and change the  color of the core label button
  */
  err = GetColorPixelValue(XtDisplay(w), cmap, rgbcolor, &sampPixel);
  XtVaSetValues(butt, XmNbackground, sampPixel, NULL);
  if(err == True) {
    xmstring = XmStringCreateSimple("black");
    XtVaSetValues(butt, XmNlabelString, xmstring, NULL);
    XmStringFree(xmstring);
    (void)strcpy(tempcolor[who], "black");
  }
  else {
    XtVaSetValues(butt, XmNlabelString, pcolor[0], NULL);
    (void)strcpy(tempcolor[who], rgbcolor);
  }
  if(who == BG_COLOR) {
    tempbgPixel = sampPixel;
    CustomColorBackgroundChange(sampPixel);
  }
  else {
    tempfgPixel[who] = sampPixel;
    if(who == CLINE_LABEL) {
      CustomColorLabelChange(sampPixel);
    }
  }
  if(rgbcolor) {
    XtFree(rgbcolor);
    rgbcolor = NULL;
  }
}

void DrawAutoCorrelate(w, dpy, xid, gc)
Widget w;
Display *dpy;
Window xid;
GC gc;
{
  char s[10];
  int i, c, n, err, high, width, x, y, inc, row, col, xoff, yoff, box_w, box_h, linelen, chosen;
  float mark, fred, redinc, fgreen, greeninc, fblue, blueinc, iter;
  Pixel pixel;
  int AutoCoreAdjAxesAndGrid(), GetColorPixelValue(), MakeBoxPixel();
  void AutoCoreAdjustDrawBox(), MakeRedGreenBlue();
  Dimension win_height, win_width;
  XColor xcolor;
  int red, green, blue, check;

  /* get the height and width of the drawing area
  */
  XtVaGetValues(w, XmNheight, &win_height, XmNwidth, &win_width, NULL);
  XClearWindow(dpy, xid);

  high = 10;
  width = 10;
  x = 100;
  y = 5;

  high = 10;
  width = 10;
  x = 100;
  y = 20;
  GetColorPixelValue(dpy, cmap, "white", &pixel);
  XSetForeground(dpy, gc, pixel);
  XFillRectangle(dpy, xid, gc, x, y, width, high);
  (void)sprintf(s,"0.0");
  XDrawString(dpy, xid, gc, x + width - 8, y - 5, s, (int)strlen(s));
  XDrawLine(dpy, xid, gc, x + width, y, x + width, y - 3);
  x = 110;
  mark = 1.0;
  iter = 10.0;
  width = 100;
  width = width/iter;

  MakeRedGreenBlue(iter, &red, &fred, &redinc, &green, &fgreen, &greeninc, &blue, &fblue, &blueinc);

  for(i=0; i<=iter; ++i) {
    xcolor.red = red * fred;
    xcolor.blue = blue * fblue;
    xcolor.green = green * fgreen;
    err = XAllocColor(dpy, cmap, &xcolor);
    if(err == 0) {
      printf("autocorr; could not alloc color; red %d  green %d  blue %d\n", xcolor.red, xcolor.green, xcolor.blue);
    }
    else {
      XSetForeground(dpy, gc, xcolor.pixel);
      XFillRectangle(dpy, xid, gc, x, y, width, high);
    }
    if(i == iter) {
      (void)sprintf(s,"1.0");
      XDrawString(dpy, xid, gc, x + width - 8, y - 5, s, (int)strlen(s));
      XDrawLine(dpy, xid, gc, x + width, y, x + width, y - 3);
    }
    x = x + width;
    fred = fred + redinc;
    fgreen = fgreen + greeninc;
    fblue = fblue + blueinc;
  }

  if(autocoreadj.in_progress == NO) {
    return;
  }

  xoff = 50;
  yoff = 80;
  err = AutoCoreAdjAxesAndGrid(w, dpy, xid, gc, xoff, yoff);
  if(err > 0) {
    return;
  }

  MakeRedGreenBlue(iter, &red, &fred, &redinc, &green, &fgreen, &greeninc, &blue, &fblue, &blueinc);

  for(i=0; i<autocoreadj.boxes_so_far; ++i) {
    row = autocoreadj.box[i]->row;
    col = autocoreadj.box[i]->col;
    if(autocoreadj.draw_results == YES && i == corr_rank.box[corr_rank.use_thisone]) {
      chosen = YES; 
    }
    else {
      chosen = NO;
    }
    check = MakeBoxPixel(&fred, &fgreen, &fblue, autocoreadj.box[i]->sum_r, chosen);
    if(check == 0) {
      xcolor.red = red * fred;
      xcolor.blue = blue * fblue;
      xcolor.green = green * fgreen;
      err = XAllocColor(dpy, cmap, &xcolor);
      if(err == 0) {
        printf("autocorr; could not alloc color; red %d  green %d  blue %d\n", xcolor.red, xcolor.green, xcolor.blue);
        GetColorPixelValue(dpy, cmap, "white", &pixel);
      }
      else {
        pixel = xcolor.pixel;
      }
    }
    else {
      GetColorPixelValue(dpy, cmap, "white", &pixel);
    }
    AutoCoreAdjustDrawBox(dpy, xid, gc, xoff, yoff, row, col, pixel, i);
  }

  if(autocoreadj.draw_results == YES) {
    pixel = BlackPixelOfScreen(XtScreen(drawingAreaCores));
    XSetForeground(dpy, gc, pixel);
    inc = 1;
    if(autocoreadj.nboxes < 9) {
      n = autocoreadj.nboxes;
    }
    else {
      n = 9;
    }
    for(i=0; i<n; ++i) {
      c = corr_rank.box[i];
      x = autocoreadj.box[c]->xpix_loc;
      y = autocoreadj.box[c]->ypix_loc;
      (void)sprintf(s,"%d", inc);
      XDrawString(dpy, xid, gc, x-2, y+5, s, (int)strlen(s));
      ++inc;
    }
  }

/*  XFreeColormap(dpy, colormap);
*/
}


int AutoCoreAdjAxesAndGrid(w, dpy, xid, gc, xoff, yoff)
Widget w;
Display *dpy;
Window xid;
GC gc;
int xoff, yoff;
{
  int i, x, y, xlinelen, ylinelen;
  char s[10];
  Dimension win_height, win_width;
  XGCValues gcValues;

  /* get the height and width of the drawing area
  */
  XtVaGetValues(w, XmNheight, &win_height, XmNwidth, &win_width, NULL);

  if((win_height - yoff - 10)/autocoreadj.nsquish >= (win_width - xoff - 10)/autocoreadj.noffset) {
    autocoreadj.box_size = (win_width - xoff - 10)/autocoreadj.noffset;
  }
  else {
    autocoreadj.box_size = (win_height - yoff - 10)/autocoreadj.nsquish;
  }
  if(autocoreadj.box_size < 3) {
    return 1;
  }

  gcValues.line_width = 0.5;
/*  XChangeGC(dpy, gc, GCLineWidth, &gcValues);
*/

  ylinelen = autocoreadj.box_size * autocoreadj.nsquish;
  y = yoff;
  x = xoff;
  XSetForeground(dpy, gc, fgPixel[CLINE_LABEL]);
  for(i=0; i<autocoreadj.noffset+1; ++i) {
    XDrawLine(dpy, xid, gc, x, y, x, y+ylinelen);
    x = x + autocoreadj.box_size;
  }

  xlinelen = autocoreadj.box_size * autocoreadj.noffset;
  y = yoff;
  x = xoff;
  XSetForeground(dpy, gc, fgPixel[CLINE_LABEL]);
  for(i=0; i<autocoreadj.nsquish+1; ++i) {
    XDrawLine(dpy, xid, gc, x, y, x+xlinelen, y);
    y = y + autocoreadj.box_size;
  }

  x = xoff;
  y = yoff;
  XDrawLine(dpy, xid, gc, x, y, x - 5, y);
  (void)sprintf(s,"%.2f", autocoreadj.range_squish[0]);
  XDrawString(dpy, xid, gc, x - 35, y + 10, s, (int)strlen(s));
  XDrawLine(dpy, xid, gc, x, y, x, y - 5);
  (void)sprintf(s,"%.2f", autocoreadj.range_offset[0]);
  XDrawString(dpy, xid, gc, x - 2, y - 8, s, (int)strlen(s));
  x = xoff + xlinelen;
  (void)sprintf(s,"%.2f", autocoreadj.range_offset[1]);
  XDrawString(dpy, xid, gc, x - 25, y - 8, s, (int)strlen(s));
  XDrawLine(dpy, xid, gc, x, y, x, y - 5);
  y = yoff + ylinelen;
  x = xoff;
  XDrawLine(dpy, xid, gc, x, y, x - 5, y);
  (void)sprintf(s,"%.2f", autocoreadj.range_squish[1]);
  XDrawString(dpy, xid, gc, x - 35, y - 2, s, (int)strlen(s));
  x = xoff + xlinelen/3.0;
  y = yoff - 20;
  (void)sprintf(s,"Offset (m)");
  XDrawString(dpy, xid, gc, x, y, s, (int)strlen(s));
  x = xoff - 40;
  y = yoff + ylinelen/2.0;
  (void)sprintf(s,"('%')");
  XDrawString(dpy, xid, gc, x, y, s, (int)strlen(s));

  gcValues.line_width = 0;
/*  XChangeGC(dpy, gc, GCLineWidth, &gcValues);
*/

   (void)sprintf(s,"");

  return 0;
}

void AutoCoreAdjustDrawBox(dpy, xid, gc, xoff, yoff, row, col, pixel, b)
Display *dpy;
Window xid;
GC gc;
int xoff, yoff; 
int row, col;
Pixel pixel;
int b;
{
  int x, y;
  char s[2];
  XGCValues gcValues;

  if(autocoreadj.box_size < 3) {
    return;
  }

  x = xoff + col * autocoreadj.box_size;
  y = yoff + row * autocoreadj.box_size;
  autocoreadj.box[b]->xpix_loc = x + autocoreadj.box_size/2.0;
  autocoreadj.box[b]->ypix_loc = y + autocoreadj.box_size/2.0;
  XSetForeground(dpy, gc, pixel);
  XFillRectangle(dpy, xid, gc, x, y, autocoreadj.box_size, autocoreadj.box_size);
  if(autocoreadj.box[b]->sum_r == BADPT) {
    pixel = BlackPixelOfScreen(XtScreen(drawingAreaCores));
    XSetForeground(dpy, gc, pixel);
    (void)sprintf(s,"x");
    XDrawString(dpy, xid, gc, autocoreadj.box[b]->xpix_loc-2, autocoreadj.box[b]->ypix_loc+5, s, (int)strlen(s));
  }
  gcValues.line_width = 0.5;
  XChangeGC(dpy, gc, GCLineWidth, &gcValues);
  XSetForeground(dpy, gc, fgPixel[CLINE_LABEL]);
  XDrawRectangle(dpy, xid, gc, x, y, autocoreadj.box_size, autocoreadj.box_size);
  gcValues.line_width = 0;
  XChangeGC(dpy, gc, GCLineWidth, &gcValues);
}

int GetColorSet()
{
  int i;

  if(colorset == EARTH_COLORSET) {
    (void)strcpy(color[CLINE_COREOVERLAYINCORR],"red");
    (void)strcpy(color[BG_COLOR],"NavajoWhite");
    (void)strcpy(color[CLINE_LABEL],"brown");
    (void)strcpy(color[CLINE_COREODPSBD],"SlateGray");
    (void)strcpy(color[CLINE_COREMCD],"DarkOliveGreen");
    (void)strcpy(color[CLINE_CORESMOOTH],"gray");
    (void)strcpy(color[CLINE_COREEQUIVLOGDEPTH],"SkyBlue");
    (void)strcpy(color[CLINE_LOG],"violet");
    (void)strcpy(color[CLINE_LOGADJDEPTH],"brown");
    (void)strcpy(color[CLINE_LOGSMOOTH],"burlywood");
    (void)strcpy(color[CLINE_TIEPT1],"red");
    (void)strcpy(color[CLINE_TIEPT2],"green");
    (void)strcpy(color[CLINE_TIELINELAST],"green");
    (void)strcpy(color[CLINE_TIELINESADJUSTDONE],"blue");
    (void)strcpy(color[CLINE_TIESELECT],"red");
    (void)strcpy(color[CLINE_COREOVERLAYINCORR],"red");
    (void)strcpy(color[CLINE_COREOVERLAYOUTCORR],"Pink");
    (void)strcpy(color[CLINE_PALEOMAG],"blue");
    (void)strcpy(color[CLINE_DIATOM],"SpringGreen");
    (void)strcpy(color[CLINE_RAD],"white");
    (void)strcpy(color[CLINE_FORAM],"HotPink");
    (void)strcpy(color[CLINE_NANNO],"brown");
    (void)strcpy(color[CLINE_CORRELATION],"ForestGreen");
    (void)strcpy(color[CLINE_CORRELATIONBEST],"yellow");
    (void)strcpy(color[CLINE_ADJUSTTOTIESSTATS], "black");
    (void)strcpy(color[CLINE_ANCILLARY1], "green");
    (void)strcpy(color[CLINE_ANCILLARY2], "burlywood");
    (void)strcpy(color[CLINE_ANCILLARY3], "salmon");
  }
  else if(colorset == CORPORATE_COLORSET) {
    (void)strcpy(color[BG_COLOR],"gainsboro");
    (void)strcpy(color[CLINE_LABEL],"black");
    (void)strcpy(color[CLINE_COREODPSBD],"ForestGreen");
    (void)strcpy(color[CLINE_COREMCD],"blue");
    (void)strcpy(color[CLINE_CORESMOOTH],"peru");
    (void)strcpy(color[CLINE_COREEQUIVLOGDEPTH],"black");
    (void)strcpy(color[CLINE_LOG],"purple");
    (void)strcpy(color[CLINE_LOGADJDEPTH],"DarkSeaGreen");
    (void)strcpy(color[CLINE_LOGSMOOTH],"gold");
    (void)strcpy(color[CLINE_TIEPT1],"red");
    (void)strcpy(color[CLINE_TIEPT2],"green");
    (void)strcpy(color[CLINE_TIELINELAST],"green");
    (void)strcpy(color[CLINE_TIELINESADJUSTDONE],"blue");
    (void)strcpy(color[CLINE_TIESELECT],"red");
    (void)strcpy(color[CLINE_COREOVERLAYINCORR],"tomato");
    (void)strcpy(color[CLINE_COREOVERLAYOUTCORR],"Pink");
    (void)strcpy(color[CLINE_PALEOMAG],"blue");
    (void)strcpy(color[CLINE_DIATOM],"SpringGreen");
    (void)strcpy(color[CLINE_RAD],"white");
    (void)strcpy(color[CLINE_FORAM],"HotPink");
    (void)strcpy(color[CLINE_NANNO],"brown");
    (void)strcpy(color[CLINE_CORRELATION],"ForestGreen");
    (void)strcpy(color[CLINE_CORRELATIONBEST],"yellow");
    (void)strcpy(color[CLINE_ADJUSTTOTIESSTATS], "black");
    (void)strcpy(color[CLINE_ANCILLARY1], "green");
    (void)strcpy(color[CLINE_ANCILLARY2], "burlywood");
    (void)strcpy(color[CLINE_ANCILLARY3], "salmon");
  }
  else if(colorset == MARITIME_COLORSET) {
    (void)strcpy(color[BG_COLOR],"MediumAquamarine");
    (void)strcpy(color[CLINE_LABEL],"SteelBlue");
    (void)strcpy(color[CLINE_COREODPSBD],"MediumSeaGreen");
    (void)strcpy(color[CLINE_COREMCD],"Salmon");
    (void)strcpy(color[CLINE_CORESMOOTH],"gray");
    (void)strcpy(color[CLINE_COREEQUIVLOGDEPTH],"DarkSlateBlue");
    (void)strcpy(color[CLINE_LOG],"purple");
    (void)strcpy(color[CLINE_LOGADJDEPTH],"tomato");
    (void)strcpy(color[CLINE_LOGSMOOTH],"thistle");
    (void)strcpy(color[CLINE_TIEPT1],"red");
    (void)strcpy(color[CLINE_TIEPT2],"green");
    (void)strcpy(color[CLINE_TIELINELAST],"green");
    (void)strcpy(color[CLINE_TIELINESADJUSTDONE],"blue");
    (void)strcpy(color[CLINE_TIESELECT],"red");
    (void)strcpy(color[CLINE_COREOVERLAYINCORR],"burlywood");
    (void)strcpy(color[CLINE_COREOVERLAYOUTCORR],"tan");
    (void)strcpy(color[CLINE_PALEOMAG],"blue");
    (void)strcpy(color[CLINE_DIATOM],"SpringGreen");
    (void)strcpy(color[CLINE_RAD],"white");
    (void)strcpy(color[CLINE_FORAM],"HotPink");
    (void)strcpy(color[CLINE_NANNO],"brown");
    (void)strcpy(color[CLINE_CORRELATION],"ForestGreen");
    (void)strcpy(color[CLINE_CORRELATIONBEST],"yellow");
    (void)strcpy(color[CLINE_ADJUSTTOTIESSTATS], "black");
    (void)strcpy(color[CLINE_ANCILLARY1], "green");
    (void)strcpy(color[CLINE_ANCILLARY2], "burlywood");
    (void)strcpy(color[CLINE_ANCILLARY3], "salmon");
  }
  else if(colorset == ODP_COLORSET) {
    (void)strcpy(color[BG_COLOR],"black");
    (void)strcpy(color[CLINE_LABEL],"white");
    (void)strcpy(color[CLINE_COREODPSBD],"gold");
    (void)strcpy(color[CLINE_COREMCD],"DodgerBlue");
    (void)strcpy(color[CLINE_CORESMOOTH],"khaki");
    (void)strcpy(color[CLINE_COREEQUIVLOGDEPTH],"SkyBlue");
    (void)strcpy(color[CLINE_LOG],"red");
    (void)strcpy(color[CLINE_LOGADJDEPTH],"purple");
    (void)strcpy(color[CLINE_LOGSMOOTH],"turquoise");
    (void)strcpy(color[CLINE_TIEPT1],"red");
    (void)strcpy(color[CLINE_TIEPT2],"green");
    (void)strcpy(color[CLINE_TIELINELAST],"green");
    (void)strcpy(color[CLINE_TIELINESADJUSTDONE],"blue");
    (void)strcpy(color[CLINE_TIESELECT],"red");
    (void)strcpy(color[CLINE_COREOVERLAYINCORR],"coral");
    (void)strcpy(color[CLINE_COREOVERLAYOUTCORR],"Pink");
    (void)strcpy(color[CLINE_PALEOMAG],"blue");
    (void)strcpy(color[CLINE_DIATOM],"SpringGreen");
    (void)strcpy(color[CLINE_RAD],"white");
    (void)strcpy(color[CLINE_FORAM],"HotPink");
    (void)strcpy(color[CLINE_NANNO],"brown");
    (void)strcpy(color[CLINE_CORRELATION],"LightSkyBlue");
    (void)strcpy(color[CLINE_CORRELATIONBEST],"yellow");
    (void)strcpy(color[CLINE_ADJUSTTOTIESSTATS], "white");
    (void)strcpy(color[CLINE_ANCILLARY1], "green");
    (void)strcpy(color[CLINE_ANCILLARY2], "burlywood");
    (void)strcpy(color[CLINE_ANCILLARY3], "salmon");
  }
  else if(colorset == SANTAFE_COLORSET) {
    (void)strcpy(color[BG_COLOR],"IndianRed");
    (void)strcpy(color[CLINE_LABEL],"wheat");
    (void)strcpy(color[CLINE_COREODPSBD],"DarkGreen");
    (void)strcpy(color[CLINE_COREMCD],"SteelBlue");
    (void)strcpy(color[CLINE_CORESMOOTH],"turquoise");
    (void)strcpy(color[CLINE_COREEQUIVLOGDEPTH],"khaki");
    (void)strcpy(color[CLINE_LOG],"purple");
    (void)strcpy(color[CLINE_LOGADJDEPTH],"Purple");
    (void)strcpy(color[CLINE_LOGSMOOTH],"pink");
    (void)strcpy(color[CLINE_TIEPT1],"red");
    (void)strcpy(color[CLINE_TIEPT2],"green");
    (void)strcpy(color[CLINE_TIELINELAST],"green");
    (void)strcpy(color[CLINE_TIELINESADJUSTDONE],"orchid");
    (void)strcpy(color[CLINE_TIESELECT],"yellow");
    (void)strcpy(color[CLINE_COREOVERLAYINCORR],"RosyBrown");
    (void)strcpy(color[CLINE_COREOVERLAYOUTCORR],"tan");
    (void)strcpy(color[CLINE_PALEOMAG],"blue");
    (void)strcpy(color[CLINE_DIATOM],"SpringGreen");
    (void)strcpy(color[CLINE_RAD],"white");
    (void)strcpy(color[CLINE_FORAM],"DeepPink");
    (void)strcpy(color[CLINE_NANNO],"thistle");
    (void)strcpy(color[CLINE_CORRELATION],"blue");
    (void)strcpy(color[CLINE_CORRELATIONBEST],"yellow");
    (void)strcpy(color[CLINE_ADJUSTTOTIESSTATS], "white");
    (void)strcpy(color[CLINE_ANCILLARY1], "DarkTurquoise");
    (void)strcpy(color[CLINE_ANCILLARY2], "tan");
    (void)strcpy(color[CLINE_ANCILLARY3], "gold");
  }
  else if(colorset == CUSTOME_COLORSET) {
    for(i=0; i<NCOLOR; ++i) {
      (void)sprintf(color[i], "");
      (void)strcpy(color[i], cust_color[i]);
    }
  }
  else {

  }
}

void SetColorSet()
{
  int i;
  void SetInitialColors(), SetColorSetBGandFG();

  SetInitialColors(XtDisplay(formMain));
  SetColorSetBGandFG();

  /* set the temp colors to the current colors using
  */
  tempbgPixel = bgPixel;
  (void)sprintf(tempcolor[BG_COLOR], "%s", color[BG_COLOR]);
  for(i=1; i<NCOLOR; ++i) {
    tempfgPixel[i] = fgPixel[i];
    (void)sprintf(tempcolor[i], "%s", color[i]);
  }
}

void MakeRedGreenBlue(n, pred, pfred, predinc, pgreen, pfgreen, pgreeninc, pblue, pfblue, pblueinc)
int *pred, *pgreen, *pblue;
float n, *pfred, *predinc, *pfgreen, *pgreeninc, *pfblue, *pblueinc;
{
  float inc;

  inc = 1.0/n;
  if(color_choice_autocorr == YELLOWTOWHITE) {
    *pred = MAXRGB;
    *pfred = 1.0;
    *predinc = 0.0;
    *pgreen = MAXRGB;
    *pfgreen = 1.0;
    *pgreeninc = 0.0;
    *pblue = MAXRGB;
    *pfblue = 1.0;
    *pblueinc = -inc;
  }
  else if(color_choice_autocorr == PURPLETOWHITE) {
    *pred = MAXRGB;
    *pfred = 1.0;
    *predinc = 0.0;
    *pgreen = MAXRGB;
    *pfgreen = 1.0;
    *pgreeninc = -inc;
    *pblue = MAXRGB;
    *pfblue = 1.0;
    *pblueinc = 0.0;
  }
  else if(color_choice_autocorr == AQUATOWHITE) {
    *pred = MAXRGB;
    *pfred = 1.0;
    *predinc = -inc;
    *pgreen = MAXRGB;
    *pfgreen = 1.0;
    *pgreeninc = 0.0;
    *pblue = MAXRGB;
    *pfblue = 1.0;
    *pblueinc = 0.0;
  }
  else if(color_choice_autocorr == BLUETOAQUA) {
    *pred = 0;
    *pfred = 1.0;
    *predinc = 0.0;
    *pgreen = MAXRGB;
    *pfgreen = 1.0;
    *pgreeninc = -inc;
    *pblue = MAXRGB;
    *pfblue = 1.0;
    *pblueinc = 0.0;
  }
  else if(color_choice_autocorr == BLUETOVIOLET) {
    *pred = MAXRGB;
    *pfred = 1.0;
    *predinc = -inc;
    *pgreen = 0;
    *pfgreen = 1.0;
    *pgreeninc = 0.0;
    *pblue = MAXRGB;
    *pfblue = 1.0;
    *pblueinc = 0.0;
  }
  else if(color_choice_autocorr == GREENTOYELLOW) {
    *pred = MAXRGB;
    *pfred = 1.0;
    *predinc = -inc;
    *pgreen = MAXRGB;
    *pfgreen = 1.0;
    *pgreeninc = 0.0;
    *pblue = 0;
    *pfblue = 1.0;
    *pblueinc = 0.0;
  }
  else if(color_choice_autocorr == GREENTOAQUA) {
    *pred = 0;
    *pfred = 1.0;
    *predinc = 0.0;
    *pgreen = MAXRGB;
    *pfgreen = 1.0;
    *pgreeninc = 0.0;
    *pblue = MAXRGB;
    *pfblue = 1.0;
    *pblueinc = -inc;
  }
  else if(color_choice_autocorr == REDTOYELLOW) {
    *pred = MAXRGB;
    *pfred = 1.0;
    *predinc = 0.0;
    *pgreen = MAXRGB;
    *pfgreen = 1.0;
    *pgreeninc = -inc;
    *pblue = 0;
    *pfblue = 1.0;
    *pblueinc = 0.0;
  }
  else if(color_choice_autocorr == REDTOVIOLET) {
    *pred = MAXRGB;
    *pfred = 1.0;
    *predinc = 0.0;
    *pgreen = 0;
    *pfgreen = 1.0;
    *pgreeninc = 0.0;
    *pblue = MAXRGB;
    *pfblue = 1.0;
    *pblueinc = -inc;
  }
  else {
    *pred = MAXRGB;
    *pfred = 1.0;
    *predinc = 0.0;
    *pgreen = MAXRGB;
    *pfgreen = 1.0;
    *pgreeninc = 0.0;
    *pblue = MAXRGB;
    *pfblue = 1.0;
    *pblueinc = -inc;
  }
}

int MakeBoxPixel(pfred, pfgreen, pfblue, r, z)
float *pfred, *pfgreen, *pfblue, r;
int z;
{
  float a;

  /* is this the chosen box to highlight?
     color it black
  */
  if(z == YES) {
    *pfred = 0.0;
    *pfgreen = 0.0;
    *pfblue = 0.0;
    return 0;
  }

  if(r < 0.0) {
    return 1; 
  }
  else if(r >= 0.0 && r < 0.1) {
    a = 1.0;
  }
  else if(r >= 0.1 && r < 0.2) {
    a = 0.9;
  }
  else if(r >= 0.2 && r < 0.3) {
    a = 0.8;
  }
  else if(r >= 0.3 && r < 0.4) {
    a = 0.7;
  }
  else if(r >= 0.4 && r < 0.5) {
    a = 0.6;
  }
  else if(r >= 0.5 && r < 0.6) {
    a = 0.5;
  }
  else if(r >= 0.6 && r < 0.7) {
    a = 0.4;
  }
  else if(r >= 0.7 && r < 0.8) {
    a = 0.3;
  }
  else if(r >= 0.8 && r < 0.9) {
    a = 0.2;
  }
  else if(r >= 0.9) {
    a = 0.1;
  }
  else {
    return 1;
  }
  if(color_choice_autocorr == YELLOWTOWHITE) {
    *pfred = 1.0; 
    *pfgreen = 1.0;
    *pfblue = a;
  }
  else if(color_choice_autocorr == PURPLETOWHITE) {
    *pfred = 1.0;
    *pfgreen = a;
    *pfblue = 1.0;
  }
  else if(color_choice_autocorr == AQUATOWHITE) {
    *pfred = a;
    *pfgreen = 1.0;
    *pfblue = 1.0;
  }
  else if(color_choice_autocorr == BLUETOAQUA) {
    *pfred = 1.0;
    *pfgreen = a;
    *pfblue = 1.0;
  }
  else if(color_choice_autocorr == BLUETOVIOLET) {
    *pfred = a;
    *pfgreen = 1.0;
    *pfblue = 1.0;
  }
  else if(color_choice_autocorr == GREENTOYELLOW) {
    *pfred = a;
    *pfgreen = 1.0;
    *pfblue = 1.0;
  }
  else if(color_choice_autocorr == GREENTOAQUA) {
    *pfred = 1.0;
    *pfgreen = 1.0;
    *pfblue = a;
  }
  else if(color_choice_autocorr == REDTOYELLOW) {
    *pfred = 1.0;
    *pfgreen = a;
    *pfblue = 1.0;
  }
  else if(color_choice_autocorr == REDTOVIOLET) {
    *pfred = 1.0;
    *pfgreen = 1.0;
    *pfblue = a;
  }
  else {
    *pfred = 1.0;
    *pfgreen = 1.0;
    *pfblue = a;
  }

  return 0;
}

void SetAncMinMax(anc)
AncillData anc;
{
  int scaleval;

  if(have_log == DONT) {
    scaleval = maxdep;
    XtVaSetValues(scaleDrawingAreas, XmNmaximum, scaleval, NULL);
    scaleval = ancill.depth_min;
    XtVaSetValues(scaleDrawingAreas, XmNvalue, scaleval, NULL);
  }
}

void SetSpliceMinMax(spl)
Splice spl;
{
  char string[20];
  int scaleval;

  (void)sprintf(string, "%.2f", spl.min);
  XtVaSetValues(textFieldVarMin, XmNvalue, string, NULL);
  (void)sprintf(string, "%.2f", spl.max);
  XtVaSetValues(textFieldVarMax, XmNvalue, string, NULL);

  if(spl.min < minvar) {
    minvar = spl.min;
  }
  if(spl.max > maxvar) {
    maxvar = spl.max;
  }

  scaleval = maxdep;
  XtVaSetValues(scaleDrawingAreas, XmNmaximum, scaleval, NULL);
}

void AutoCorrDrawSelectedBox(dpy, xid, gc)
Display *dpy;
Window xid;
GC gc;
{
  char s[10];
  int  err, x, y, row, col, xoff, yoff, box;
  float fred, redinc, fgreen, greeninc, fblue, blueinc, iter;
  Pixel pixel;
  int GetColorPixelValue(), MakeBoxPixel();
  void AutoCoreAdjustDrawBox(), MakeRedGreenBlue();
  XColor xcolor;
  int red, green, blue, check;

  iter = 10;
  xoff = 50;
  yoff = 80;

  MakeRedGreenBlue(iter, &red, &fred, &redinc, &green, &fgreen, &greeninc, &blue, &fblue, &blueinc);

  box = corr_rank.box[corr_rank.previous_one];
  row = autocoreadj.box[box]->row;
  col = autocoreadj.box[box]->col;
  check = MakeBoxPixel(&fred, &fgreen, &fblue, autocoreadj.box[box]->sum_r, NO);
  if(check == 0) {
    xcolor.red = red * fred;
    xcolor.blue = blue * fblue;
    xcolor.green = green * fgreen;
    err = XAllocColor(dpy, cmap, &xcolor);
    if(err == 0) {
      printf("autocorr; could not alloc color; red %d  green %d  blue %d\n", xcolor.red, xcolor.green, xcolor.blue);
      GetColorPixelValue(dpy, cmap, "white", &pixel);
    }
    else {
      pixel = xcolor.pixel;
    }
  }
  else {
    GetColorPixelValue(dpy, cmap, "white", &pixel);
  }
  AutoCoreAdjustDrawBox(dpy, xid, gc, xoff, yoff, row, col, pixel, box);

  if(corr_rank.previous_one < 9) {
    pixel = BlackPixelOfScreen(XtScreen(drawingAreaCores));
    XSetForeground(dpy, gc, pixel);
    x = autocoreadj.box[box]->xpix_loc;
    y = autocoreadj.box[box]->ypix_loc;
    (void)sprintf(s,"%d", corr_rank.previous_one+1);
    XDrawString(dpy, xid, gc, x-2, y+5, s, (int)strlen(s));
  }

  box = corr_rank.box[corr_rank.use_thisone];
  row = autocoreadj.box[box]->row;
  col = autocoreadj.box[box]->col;
  check = MakeBoxPixel(&fred, &fgreen, &fblue, autocoreadj.box[box]->sum_r, YES);
  if(check == 0) {
    xcolor.red = red * fred;
    xcolor.blue = blue * fblue;
    xcolor.green = green * fgreen;
    err = XAllocColor(dpy, cmap, &xcolor);
    if(err == 0) {
      printf("autocorr; could not alloc color; red %d  green %d  blue %d\n", xcolor.red, xcolor.green, xcolor.blue);
      GetColorPixelValue(dpy, cmap, "white", &pixel);
    }
    else {
      pixel = xcolor.pixel;
    }
  }
  else {
    GetColorPixelValue(dpy, cmap, "white", &pixel);
  }
  AutoCoreAdjustDrawBox(dpy, xid, gc, xoff, yoff, row, col, pixel, box);
}

DrawEvalCoreLogData(w, dpy, xid, gc)
Widget w;
Display *dpy;
Window xid;
GC gc;
{
  int i, k, sx, sy, sdx, sdy, pointsize, xoff;
  char s[10];
  float logvarperpix, corevarperpix, minl, maxl, minc, maxc;
  Dimension win_height, win_width;
  void Round();

  /* get the height and width of the drawing area
  */
  XtVaGetValues(w, XmNheight, &win_height, XmNwidth, &win_width, NULL);

  /*clear the drawing area
  */
  XClearWindow(dpy, xid);

  if(datapairs_cnt < 1) {
    return;
  }

  logvarperpix = (maxlog - minlog)/(win_height - (OFF + OFF));
  corevarperpix = (maxvar - minvar)/(win_width - (OFF + OFF));
  xoff = OFF;

  minl = minlog;
  maxl = maxlog;
  minc = minvar;
  maxc = maxvar;
  Round(&minl, 1.0);
  Round(&maxl, 1.0);
  Round(&minc, 1.0);
  Round(&maxc, 1.0);
  sx = (maxl - minl)/logvarperpix + xoff;
  sy = -1.0 * (maxc - minc)/corevarperpix + win_height - xoff;
  XSetForeground(dpy, gc, fgPixel[CLINE_LABEL]);
  XDrawLine(dpy, xid, gc, xoff, win_height - xoff, sx, win_height - xoff);
  XDrawLine(dpy, xid, gc, xoff, win_height - xoff, xoff, sy); 
  (void)sprintf(s,"%.0f", minl);
  XDrawString(dpy, xid, gc, xoff - 10, win_height - xoff + 20, s, (int)strlen(s));
  (void)sprintf(s,"%.0f", maxl);
  XDrawString(dpy, xid, gc, sx - 20, win_height - xoff + 20, s, (int)strlen(s));
  (void)sprintf(s,"%.0f", minc);
  XDrawString(dpy, xid, gc, xoff - 30, win_height - xoff, s, (int)strlen(s));
  (void)sprintf(s,"%.0f", maxc);
  XDrawString(dpy, xid, gc, xoff - 30, sy + 2, s, (int)strlen(s));
  (void)sprintf(s,"Core");
  XDrawString(dpy, xid, gc, xoff - 45, win_height/2, s, (int)strlen(s));
  (void)sprintf(s,"Log");
  XDrawString(dpy, xid, gc, sx/2 - 10, win_height - xoff + 30, s, (int)strlen(s));
  
  XSetForeground(dpy, gc, fgPixel[CLINE_CORRELATIONBEST]);
  for(k=0; k<datapairs_cnt; ++k) {
    if(logcoredatapairs[k]->n < 1) {
    }
    else {
      for(i=0; i<logcoredatapairs[k]->n; ++i) {
        if(logcoredatapairs[k]->logdat[i] != BADPT && logcoredatapairs[k]->coredat[i] != BADPT) {
          sx = (logcoredatapairs[k]->logdat[i] - minlog)/logvarperpix + xoff;
          sy = -1.0 * (logcoredatapairs[k]->coredat[i] - minvar)/corevarperpix + win_height - xoff;
          pointsize = 5;
          XFillArc(dpy, xid, gc, sx-(pointsize/2), sy-(pointsize/2), pointsize, pointsize, 0, 360*64);
        }
      }
    }
  }

  /* draw the linear eqt
  */
  sx = xoff;
  sy = -1.0 * (datapairs_b - minvar)/corevarperpix + win_height - xoff;
  sdx = (maxlog - minlog)/logvarperpix + xoff;
  sdy = -1.0 * (((datapairs_a * maxlog) + datapairs_b) - minvar)/corevarperpix + win_height - xoff;
  XDrawLine(dpy, xid, gc, sx, sy, sdx, sdy);
}
